/*========================================================================*/
/*┌更新履歴――――――――――――――――――――――――――――――┐*/
/*｜14/01/16    プロジェクト用意                                        ｜*/
/*｜14/01/23    C++からのアルゴリズム移植                               ｜*/
/*｜14/01/30    文字、画像表示、タップ入力追加                          ｜*/
/*｜14/02/06    スクロール追加、判定修正、表示位置調整、実機動作確認    ｜*/
/*｜14/02/13    xcode4.2⇔5/iphone4s⇔5対応、十字/ポーズ/半速ボタン追加 ｜*/
/*└――――――――――――――――――――――――――――――――――┘*/
/*========================================================================*/

//======================================================================
//┌更新予定――――――――――――――――――――――――――――――
//｜絵：透過
//｜入力：摘み移動
//｜音：
//｜実機調整：画面の固定、xcode対応
//└――――――――――――――――――――――――――――――――――
//======================================================================
#if 0

//コメント
//
//  ViewController.h
//  test5
//
//  Created by Profire staff on 2014/01/20.
//  Copyright (c) 2014年 Profire staff. All rights reserved.
//
#endif

/*====================================================================
//定数
====================================================================*/
#define XCODE_42          1     // xcode4.2コンパイルスイッチ
#define IPHONE5           0     // retina4インチ　ワイド画面対応
#define NO_DEATH_WALL     1     // デバッグモード　壁判定で死なない(時間や敵では死ぬ)

#define MAP_WIDTH       800     // ウインドウの幅
#define MAP_HEIGHT      600     // ウインドウの高さ
#define MOVABLE_BAR       0     // MOVABLE_RIGHT
#define MOVABLE_UNDER   (MAP_HEIGHT-SELF_IMG_SIZE)
#define MOVABLE_LEFT      0     // 移動可能範囲X
#define MOVABLE_RIGHT   (MAP_WIDTH-SELF_IMG_SIZE)

#define MEMORY          256     // 文字列格納文字数

#define SELF_IMG_SIZE    32     // 自機画像サイズ
#define SPEED             2.5   // プレイヤーの通常スピード
#define LIFE_INIT         9     // 残機
#define BLINK_FRAME      10     // 瞬き

#define FONT_TITLE       54     // タイトル
#define FONT_NORMAL      18     // 通常
#define FONT_STGLD        9     // ステージロード

#define BUTTON_SIZE      54     // ボタン

#if IPHONE5
  #define WIDE_HEIGHT    88
#else
  #define WIDE_HEIGHT     0
#endif
#if XCODE_42
  #define BAR_OFFSET      0
#else
  #define BAR_OFFSET      0
#endif
#define WINDOW_WIDTH    320    // windowの大きさ
#define WINDOW_HEIGHT   (480+WIDE_HEIGHT-BAR_OFFSET)

#define EXTENSION_MP3   @"mp3"
#define EXTENSION_WAV   @"wav"
#define EXTENSION_MID   @"mid"


enum{   //画面状態遷移用
    TITLE = 0       ,
    DICEDE          ,
    LOAD_STAGE      ,
    STAGE           ,
    DEATH           ,
    DEATH2          ,
    GAMEOVER        ,
    ENDING          ,

    STATE_END
};

enum{   //音楽番号
    BGM_TITLE       ,   // 0.タイトルBGM
    BGM_STAGE1      ,   // 1.ゲーム中BGM1面
    BGM_STAGE2      ,   // 2.ゲーム中BGM2面
    BGM_STAGE3      ,   // 3.ゲーム中BGM3面
    BGM_STAGE4      ,   // 4.ゲーム中BGMEX面
    BGM_STAGE5      ,   // 5.ゲーム中BGM5面
    BGM_STAGE6      ,   // 6.ゲーム中BGM6面(ラスト)
    BGM_GOAL        ,   // 7.勝利音楽
    BGM_LOSE        ,   // 8.死亡時音楽
    BGM_ENDING      ,   // 9.エンディング音楽

    SE_DECIDE       ,   //10.決定音
    SE_LOST         ,   //11.死亡時音
    SE_ENDSCORE     ,   //12.初ハイスコア表示

    BGM_END
};

enum{   //画像番号
    TOPTITLE        ,   // タイトル
    TITLE_MOJI      ,   // タイトル文字
    JIKI0           ,   // 自機0
    JIKI1           ,   // 自機1
    JIKI2           ,   // 自機2
    JIKI3           ,   // 自機3
    JIKI4           ,   // 自機4
    JIKI5           ,   // 自機5
    JIKI_GOAL       ,   // 自機ゴール
    JIKI_DEATH      ,   // 自機死亡
    FAIRY           ,   // 妖精
    STAGE1_IMG      ,   // 1面
    STAGE2_IMG      ,   // 2面
    STAGE_EX        ,   // 特別面
    STAGE4_IMG      ,   // 3面
    STAGE5_IMG      ,   // 4面
    STAGE6_IMG      ,   // 5面

    IMG_END
};

enum{   //文字列表示位置番号
    HISCORE_POS     ,   //  0. ハイスコア
    TITLE_POS       ,   //  1. タイトル
    PRESSENTER_POS  ,   //  2. Press Enter
    DEBUG_POS       ,   //  3. デバッグ用
    COPYRIGHT_POS   ,   //  4. コピーライト

    REMAIN_POS      ,   //  5. 残機
    STAGE_POS       ,   //  6. STAGE
    LOADING_POS     ,   //  7. LOADING...
    WAITFEWSEC_POS  ,   //  8. please wait about ～sec!

    SELF_POS        ,   //  9. 自機
    DIED_POS        ,   // 10. YOU DIED!
    DIED_ENTER_POS  ,   // 11. press enter
    GOAL_POS        ,   // 12. ゴール！
    TIMELIMIT_POS   ,   // 13. TIME

    HELPHINT_POS1   ,   // 14. ヘルプアテンション(ヒント注釈)
    HELPHINT_POS2   ,   // 15. ヘルプアテンション(ヒント注釈)

    STUFFROLL1      ,   // 16. スタッフロール作業
    STUFFROLL2      ,   // 17. スタッフロール名前

    SHOWSCORE1_POS  ,   // 18. 各ステージクリア時取得スコア表示
    SHOWSCORE2_POS  ,   // 19. 各ステージクリア時取得スコア表示
    SHOWSCORE3_POS  ,   // 20. 各ステージクリア時取得スコア表示
    SHOWSCORE4_POS  ,   // 21. 各ステージクリア時取得スコア表示
    SHOWSCORE5_POS  ,   // 22. 各ステージクリア時取得スコア表示
    SHOWSCORE6_POS  ,   // 23. 各ステージクリア時取得スコア表示

    SUMSCORE_POS    ,   // 24. 合計
    SUMSCORENUM_POS ,   // 25. 合計スコア
    YOUWON_POS      ,   // 26. 君は勝った
    CONGRATULATE_POS,   // 27. おめでとう
    ENDPRESS_POS    ,   // 28. エンターを押してね

    HELPHINT_POS2_1 ,   // 29. ヘルプアテンション(ヒント注釈)
    HELPHINT_POS2_2 ,   // 30. ヘルプアテンション(ヒント注釈)

    STOP_TIME_POS   ,   // 31. PAUSE

    POS_END
};

enum{   // ボタン用
    LEFT,       // ←
    UP,         // ↑
    DOWN,       // ↓
    RIGHT,      // →
    TIME,       // タイム
    HALF_SPEED, // 半速
    
    BTN_END
};

/*==============================================================================
!インクルード
==============================================================================*/
#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>
#if !XCODE_42
 #import <SpriteKit/SpriteKit.h>
#endif
#import <AudioToolbox/AudioToolbox.h>
#import <AVFoundation/AVFoundation.h>

#include<wchar.h>
#include<stdio.h>
#include<time.h>
#include<stdlib.h>
#include<string.h>


/*==============================================================================
//クラス・構造体
==============================================================================*/
@class EditWindow;

@interface ViewController : UIViewController{

    CGPoint _tBegan;   // スライド用(タップ瞬間)
    CGPoint _tEnded;   // スライド用(アンタップ時)
    CGPoint _tMoved;   // スライド用(タップ中)
    bool    pick;      // 字キャラつまみ用
}

@end

typedef struct _D3DRECT {
    long x1, y1;    //x,y
    long width, height;    //width,height
} RECT;


/*==============================================================================
// プロトタイプ宣言
==============================================================================*/
void Update(void);          //更新処理
void Draw(void);            //描画処理

void print_img(short , NSString* , float , float , float , float , float , float);   //画像表示

void title(void);               //タイトル画面表示
void PlayStart(void);           //タイトル決定処理用
void stage_init(void);          //ステージ初期化
void SetMoveSpeed(void);        //移動スピード設定
void Move(void);                //プレイヤーの移動
void glide(void);               //滑る
void hantei(void);              //判定
void debug_print(void);         //デバッグ表示
void death_move(void);          //死んだ時の挙動
void death2_screen(void);       //死に画面
void dying(void);               //死に→復帰(黒画面)
void glide_LR(void);            //滑る左右
void chara_anime(void);         //キャラのアニメ
void time_limit(void);          //制限時間

void LoadAndDrowDot(void);      //ステージ点表示

//iphone用追加------------
void reset_input(void);         //入力のリセット
void print_str(int /*フォント*/ , char* /*文字*/ , int /*表示位置*/ , float /*R*/ , float /*G*/ , float /*B*/);
void print_btn(int /*フォント*/ , char* /*文字*/ , int /*表示位置*/ , float /*R*/ , float /*G*/ , float /*B*/);
void doScroll(void);            //画面スクロール
void drawMap(void);             //マップチップの描画
void PlayMusic(int , NSString* , bool); //音楽の再生
void StopMusic(int);            //音楽の停止

/*==============================================================================
//グローバル構造体変数
==============================================================================*/
/*
extern LPDIRECTINPUTDEVICE8	g_pDIDevJoypad[MAX_CONTROLER];  //ゲームパッドの有無確認用
VERTEX_2D					g_vertexWk[4];			        //頂点情報格納ワーク
D3DXIMAGE_INFO				*info;                          //透過用
*/

RECT        hanni;
char        *t_szbuf;   //文字列格納用
char        *str2;
NSString    *word;


static NSString *bgm[BGM_END]={
    // BGM\*.mid
    @"title_ma-jan"     ,   // 0.タイトルBGM
    @"stage1_fz2"       ,   // 1.ゲーム中BGM1面
    @"stage2_hebe_pass" ,   // 2.ゲーム中BGM2面
    @"stage3_fz4"       ,   // 3.ゲーム中BGM3面
    @"stage4_ya-da-yo"  ,   // 4.ゲーム中BGMEX面
    @"stage5_ff6"       ,   // 5.ゲーム中BGM5面
    @"stage6_vsbd2"     ,   // 6.ゲーム中BGM6面(ラスト)
    @"mario4_goal"      ,   // 7.勝利音楽
    @"bk_go"            ,   // 8.死亡時音楽
    @"clear"            ,   // 9.エンディング音楽
    // SE\*.wav
    @"Sound_Decide"     ,   //10.決定音
    @"p"                ,   //11.死亡時音
    @"EX"               ,   //12.エンドハイスコア表示時
};

static NSString *str_moji[IMG_END]={
    @"toptitle.png"   ,   // タイトル
    @"backbaird.png"  ,   // タイトル文字
    @"jiki0.png"      ,   // 自機0
    @"jiki1.png"      ,   // 自機1
    @"jiki2.png"      ,   // 自機2
    @"jiki3.png"      ,   // 自機3
    @"jiki4.png"      ,   // 自機4
    @"jiki5.png"      ,   // 自機5
    @"jiki_goal.png"  ,   // 自機ゴール
    @"jiki_death.png" ,   // 自機死亡
    @"fairy.png"      ,   // 妖精
    @"stage1.png"     ,   // 1面
    @"stage2.png"     ,   // 2面
    @"no.png"         ,   // 特別面
    @"stage4.png"     ,   // 3面
    @"stage5.png"     ,   // 4面
    @"stage6.png"     ,   // 5面
};

RECT rect[]={                                       // 文字表示位置
    { 100,   25 , MAP_WIDTH , MAP_HEIGHT } ,  //  0. ハイスコア
    {   0,   25 , MAP_WIDTH , MAP_HEIGHT } ,  //  1. タイトル
    { 112,  360 , MAP_WIDTH , MAP_HEIGHT } ,  //  2. Please Tap
    {   0,    0 , MAP_WIDTH , MAP_HEIGHT } ,  //  3. デバッグ用
    { 110,  450 , MAP_WIDTH , MAP_HEIGHT } ,  //  4. コピーライト

    { 162 , 220 , MAP_WIDTH , MAP_HEIGHT } ,  //  5. 残機
    { 125 , 252 , MAP_WIDTH , MAP_HEIGHT } ,  //  6. STAGE
    { 140 , 287 , MAP_WIDTH , MAP_HEIGHT } ,  //  7. LOADING...
    { 100 , 300 , MAP_WIDTH , MAP_HEIGHT } ,  //  8. please wait about ～sec!

    { 162 ,  12 , MAP_WIDTH , MAP_HEIGHT } ,  //  9. 自機
    { 120 , 220 , MAP_WIDTH , MAP_HEIGHT } ,  // 10. YOU DIED!
    { 135 , 245 , MAP_WIDTH , MAP_HEIGHT } ,  // 11. press enter
    {  87 , 225 , MAP_WIDTH , MAP_HEIGHT } ,  // 12. ゴール！
    {  32 ,  16 , MAP_WIDTH , MAP_HEIGHT } ,  // 13. TIME

    { 0.6 , 325 , MAP_WIDTH , MAP_HEIGHT } ,  // 14. ヘルプアテンション
    { 125 , 350 , MAP_WIDTH , MAP_HEIGHT } ,  // 15. ヘルプヒント

    {  60 , 220 , MAP_WIDTH , MAP_HEIGHT } ,  // 16. エンディングスタッフロール
    { 125 , 240 , MAP_WIDTH , MAP_HEIGHT } ,  // 17. エンディングスタッフロール
    
    {  60 , 120 , MAP_WIDTH , MAP_HEIGHT } ,  // 18. 各ステージ取得スコア表示
    {  60 , 140 , MAP_WIDTH , MAP_HEIGHT } ,  // 19. 各ステージ取得スコア表示
    {  60 , 160 , MAP_WIDTH , MAP_HEIGHT } ,  // 20. 各ステージ取得スコア表示
    {  60 , 180 , MAP_WIDTH , MAP_HEIGHT } ,  // 21. 各ステージ取得スコア表示
    {  60 , 200 , MAP_WIDTH , MAP_HEIGHT } ,  // 22. 各ステージ取得スコア表示
    {  60 , 220 , MAP_WIDTH , MAP_HEIGHT } ,  // 23. 各ステージ取得スコア表示

    {  56 , 260 , MAP_WIDTH , MAP_HEIGHT } ,  // 24. 合計
    { 200 , 260 , MAP_WIDTH , MAP_HEIGHT } ,  // 25. 合計スコア

    { 100 , 300 , MAP_WIDTH , MAP_HEIGHT } ,  // 26. 君は勝った！
    {  56 , 320 , MAP_WIDTH , MAP_HEIGHT } ,  // 27. おめでとう☆
    {  95 , 340 , MAP_WIDTH , MAP_HEIGHT } ,  // 28. エンターを押してね

    { 125 , 375 , MAP_WIDTH , MAP_HEIGHT } ,  // 29. ヘルプアテンション2
    { 125 , 400 , MAP_WIDTH , MAP_HEIGHT } ,  // 30. ヘルプヒント2

    { 140 , 220 , MAP_WIDTH , MAP_HEIGHT } ,  // 31. タイムの時の文字位置

};

RECT rect_btn[]={
    {   0 , WINDOW_HEIGHT-BUTTON_SIZE-25 , 0 , 0 } ,  // ←
    {  25 , WINDOW_HEIGHT-BUTTON_SIZE-50 , 0 , 0 } ,  // ↑
    {  25 , WINDOW_HEIGHT-BUTTON_SIZE    , 0 , 0 } ,  // ↓
    {  50 , WINDOW_HEIGHT-BUTTON_SIZE-25 , 0 , 0 } ,  // →

    { WINDOW_WIDTH/2           , WINDOW_HEIGHT-BUTTON_SIZE , 0 , 0 } ,  // タイム
    { WINDOW_WIDTH-BUTTON_SIZE , WINDOW_HEIGHT-BUTTON_SIZE , 0 , 0 } ,  // 半速
    
};

/*==============================================================================*/
//予約後変数
/*==============================================================================*/

const int stage[6][MAP_HEIGHT/2][MAP_WIDTH/2] ={
    #include "../stage/stage1.csv"
    #include "../stage/stage2.csv"
    {0,0,0,0},
    #include "../stage/stage4.csv"
    #include "../stage/stage5.csv"
    #include "../stage/stage6.csv"
}; 
long mouse_pos_x;                //マウスの座標X
long mouse_pos_y;                //マウスの座標Y

float jiki_x;
float jiki_y;
float move_speed        = 0;            //1Pのスピード
float death_move_speed  = 0;            //死んだ時の移動スピード

//スイッチ系
bool s_ini              = false;        //バトル初期化スイッチ
bool decide             = false;        //タイトル決定中判定用
bool music_on           = false;        //音楽を鳴らしているのかないのか
bool sound_on           = false;
bool write_screen       = false;        //ステージ描画初期化スイッチ
bool fall_switch        = false;        //死んだ時のスイッチ
bool goal               = false;        //ゴール判定
bool stop_time_switch   = false;
bool scroll_speedup     = false;

int prev_ground_slide   = 0;            //前入力の残りで移動滑り
int prev_ground_slide_LR= 0;            //前入力の残り(左右)
int death_flg           = 0;            //死に画面への移行用
int state               = TITLE;        //状態
int stage_num           = STAGE1_IMG;
int bgm_no              = BGM_STAGE1;
int life                = 3;            //機数
int enemy_speed         = -3;
int scroll_speed        = 1;
int time_limit_val      = 100;
int score               = 0;
int hiscore             = 0;
int scroll_y            = 0;            //エンディング関係------------
int cntFrame            = 0;            //カウントフレーム
int wait_time_cnt       = 1;            //待ち時間カウント用
int show_score_cnt      = 1;

int end_show_score[6];
int enemy[2];                           //0...y,1...x

#if MOTION
 extern int global_test_xx ;            //変換用グローバル変数
#else
 int global_test_xx = 99999;
#endif

#if !aaaiaia
int aa=0;
#endif


//迷路自動作製用-----------------------------------
#define BLOCK_SIZE 50

typedef struct{
    int x;
    int y;
}POS;

//グローバルエリア
POS r_move[4] = {
    { -1 , 0 } ,    //左
    {  0 ,-1 } ,    //上
    {  1 , 0 } ,    //右
    {  0 , 1 } ,    //下
};

int *map;       //マップデータ
int mapsize;    //マップサイズ

POS MapPos = { 0 , 2 }; //現在マップ位置
                        //初期値：スタート

int SubCount = 0;   //深度カウンタ
int MaxCount = 0;   //最大深度
POS GoalPos;    //ゴール位置

const int mapDat[3] = {   //マップパーツ
    0,             // 0 壁
    255,           // 1 掘った穴
    2,             // 2 ゴール
};

void mapCreate( POS );  //マップ作製関数(再帰)
void mapDisp(void);     //マップ表示関数

void print_wall();      //壁表示
//迷路自動作製用-----------------------------------


//iphone用追加-----------------------------------------------------

int map_scroll_x;   //描画位置調整用
int map_scroll_y;

int maptip_num = 0; //マップチップ番号

int preTime = 0;    //タッチした時のカウント値

int ending_scroll_y   = 0;
float move_speed_line = 0; //移動速度(横)



//ループ再生位置設定
#if XCODE_42 || N_CPP
const static double bgm_seek_set[]={
#else
constexpr const static double bgm_seek_set[]={
#endif
    31.1 ,  // 0.タイトルBGM
    36   ,  // 1.ゲーム中BGM1面
     0   ,  // 2.ゲーム中BGM2面
     3.5 ,  // 3.ゲーム中BGMEX面
     4.5 ,  // 4.ゲーム中BGM4面
     0   ,  // 5.ゲーム中BGM5面
     0   ,  // 6.ゲーム中BGM6面(ラスト)

};
//再生終了位置設定
#if XCODE_42 || N_CPP
const static double bgm_seek_end[]={
#else
constexpr const static double bgm_seek_end[]={
#endif
   60*1+ 1-0.4 ,   // 0.タイトルBGM
   60*1+ 6-0.0 ,   // 1.ゲーム中BGM1面
   60*1+16-0.0 ,   // 2.ゲーム中BGM2面
   60*1+23-0.5 ,   // 3.ゲーム中BGMEX面
   60*0+45-1.0 ,   // 4.ゲーム中BGM4面
   60*0+46-0.5 ,   // 5.ゲーム中BGM5面
   60*0+52-0.5 ,   // 6.ゲーム中BGM6面(ラスト)
};
