
#import "ViewController.h"

@interface ViewController (){
}
@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.

    view = self;

    t_szbuf = (char*)malloc(sizeof(char)*MEMORY);   //文字格納用配列確保

    // 文字表示領域確保
    for(int i = 0; i < POS_END; i++){
        label[i] = [[UILabel alloc] init];
    }
    uv = [[UIView alloc] init]; // 背景塗りつぶし用
    for(int i = 0; i < MEMORY; i++){
        stage_ex[i] = [[UIView alloc] init];
    }
    // ボタン確保
    for(int i = 0; i < BTN_END; i++){
#if XCODE_42
        button[i] = [UIButton buttonWithType:UIButtonTypeCustom];
#else
        button[i] = [UIButton buttonWithType:UIButtonTypeRoundedRect];
#endif
    }
#if NO_DEATH_WALL
    debug_button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
#endif
    //ランダムマップ作製
    mapsize = ( MAP_HEIGHT / (BLOCK_SIZE) ) ;    //マップチップ数
    //マップサイズ(チップ数)が割り切れた時、奇数にする
    if(mapsize % 2 == 0){
        mapsize--;
    }
    map = (int*)malloc( sizeof(int)*(mapsize * mapsize) );
    memset(map , 0 , sizeof(int)*(mapsize * mapsize) );
    mapCreate(MapPos);
    *(map + GoalPos.y * mapsize + GoalPos.x) = 2;   //ゴール位置設定

    // ステータスバーを非表示にする
    [UIApplication sharedApplication].statusBarHidden = YES;


    float fps = (1.0f/60.0f);
    [NSTimer scheduledTimerWithTimeInterval:fps
                                     target:self
                                   selector:@selector(mainloop)
                                   userInfo:Nil
                                    repeats:YES];
}


/*============================================================================
●メインループ(引数なし)
//戻り値：なし
============================================================================*/
-(void)mainloop{
    Update();
    Draw();
    reset_input();    // 入力情報の更新
    doScroll();
    
}


/*============================================================================
●タップしたとき()
//戻り値：なし
============================================================================*/
-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {

    //入力用
    pick = false;
    tap = true;
    preTime = cntFrame;

    //スワイプ用
    UITouch * touchBegan = [touches anyObject];
    _tBegan = [ touchBegan locationInView: self.view ];

//  if(touchBegan.state == UIControlStateHighlighted){}

    /*指(指が自機に重なった時タップしていたら、自機が指に追従する)
    if(jiki_y-map_scroll_y <= _tBegan.y  && _tBegan.y <= jiki_y-map_scroll_y + SELF_IMG_SIZE      //マウス座標Yが自機(縦)の範囲内
    && jiki_x-map_scroll_x <= _tBegan.x  && _tBegan.x <= jiki_x-map_scroll_x + SELF_IMG_SIZE){    //マウス座標Xが自機(横)の範囲内
        if(stop_time_switch == false){
            //jiki_y = (float)(_tBegan.y+map_scroll_y-(SELF_IMG_SIZE/2));
            //jiki_x = (float)(_tBegan.x+map_scroll_x-(SELF_IMG_SIZE/2));
        }
        pick = true;
    }
    else{
        pick = false;
    }*/

}
/*============================================================================
●指を動かしているとき()
//戻り値：なし
============================================================================*/
- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event
{
    UITouch * touchMoved = [touches anyObject];
    _tMoved = [ touchMoved locationInView: self.view ];

    NSInteger distanceHorizontal = ABS( _tMoved.x - _tBegan.x );
    NSInteger distanceVertical = ABS( _tMoved.y - _tBegan.y );
    preTime = cntFrame - preTime;

    if(state == STAGE && goal == 0){

        if ( _tMoved.x > _tBegan.x ) {
            // 右にスワイプした時の処理をここに書く
            right_move = true;
            //NSLog(@"右にスワイプ");
            // 例えば、前の画面に戻る処理
            //[[self navigationController] popViewControllerAnimated:YES];
        }
        else {
            // 左にスワイプした時の処理をここに書く
            if(_tMoved.x != _tBegan.x){
                left_move = true;
            }
            //NSLog(@"左にスワイプ");
        }
        if(preTime != 0){
            move_speed_line = distanceHorizontal/preTime;
        }
        if ( _tMoved.y > _tBegan.y ) {
            // 下にスワイプした時の処理をここに書く
            down_move = true;
            //NSLog(@"下にスワイプ");
        }
        else {
            // 上にスワイプした時の処理をここに書く
            if(_tMoved.y != _tBegan.y){
                up_move = true;
            }
            //NSLog(@"上にスワイプ");
        }
        if(preTime != 0){
            move_speed = distanceVertical/preTime;
        }
        /*指(指が自機に重なった時タップしていたら、自機が指に追従する)
        if(jiki_y-map_scroll_y <= _tMoved.y  && _tMoved.y <= jiki_y-map_scroll_y + SELF_IMG_SIZE      //マウス座標Yが自機(縦)の範囲内
        && jiki_x-map_scroll_x <= _tMoved.x  && _tMoved.x <= jiki_x-map_scroll_x + SELF_IMG_SIZE){    //マウス座標Xが自機(横)の範囲内
            if(stop_time_switch == false){
                //jiki_y += (float)(_tMoved.y - _tBegan.y -map_scroll_y-(SELF_IMG_SIZE/2));
                //jiki_x += (float)(_tMoved.x - _tBegan.x -map_scroll_x-(SELF_IMG_SIZE/2));
            }
            pick = true;
        }
        else{
            pick = false;
        }*/
    }
}




/*============================================================================
●手を離したとき()
//戻り値：なし
============================================================================*/
-(void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event{
    UITouch * touchEnded = [touches anyObject];
    _tEnded = [ touchEnded locationInView: self.view ];
    NSInteger distanceHorizontal = ABS( _tEnded.x - _tBegan.x );
    NSInteger distanceVertical = ABS( _tEnded.y - _tBegan.y );
 
    //NSLog(@"%d", distanceHorizontal);
    //NSLog(@"%d",  distanceVertical);
    if(pick == true){
        return;

    }
    tap = false;
    return;

    if ( distanceHorizontal > distanceVertical ) {
        if ( _tEnded.x > _tBegan.x ) {
            // 右にスワイプした時の処理をここに書く
            right_move = true;
            //NSLog(@"右にスワイプ");
            // 例えば、前の画面に戻る処理
            //[[self navigationController] popViewControllerAnimated:YES];
        }
        else {
            // 左にスワイプした時の処理をここに書く
            if(_tEnded.x != _tBegan.x){
                left_move = true;
            }
            //NSLog(@"左にスワイプ");
        }
        move_speed = distanceHorizontal/25;
    }
    else {
        if ( _tEnded.y > _tBegan.y ) {
            // 下にスワイプした時の処理をここに書く
            down_move = true;
            //NSLog(@"下にスワイプ");
        }
        else {
            // 上にスワイプした時の処理をここに書く
            if(_tEnded.y != _tBegan.y){
                up_move = true;
            }
            //NSLog(@"上にスワイプ");
        }
        move_speed = distanceVertical/25;
    }

}


/*============================================================================
●メモリが足りなくなったとき(引数なし)
//戻り値：なし
============================================================================*/
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
    
    
}

/*============================================================================
●回転禁止(UIInterfaceOrientation)
//戻り値：false
============================================================================*/
- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{   
    [UIApplication sharedApplication].statusBarOrientation = UIInterfaceOrientationPortrait; //縦固定の例
    return YES;
}
 


//========================================================================================================================================================

/*============================================================================
●更新処理(引数なし)
//戻り値：なし
============================================================================*/
void Update(void)
{
    //ループシークの調整
    if(g_bgm_num <= BGM_STAGE6){
        if(player.currentTime > bgm_seek_end[g_bgm_num]){
            player.currentTime = bgm_seek_set[g_bgm_num];
        }
    }
    if(stop_time_switch == false){
        cntFrame++;
    }
    switch(state){
        case TITLE: //タイトル---------------------------------------
            //まだ決めてない場合は選択可能
            if(!decide){
                //ミュージックスタート
                if(!music_on){
                    PlayMusic( BGM_TITLE , EXTENSION_MP3 , true);
                    music_on = true;
                }

                PlayStart();
            }
            //決めた場合は、その瞬間音楽を止め、効果音
            else{
                wait_time_cnt++;
                //１秒待つ
                if(wait_time_cnt % 60 == 0){
                    score = 0;
                    life = LIFE_INIT;
                    stage_num = STAGE1_IMG;
                    state = /*ENDING;*/LOAD_STAGE;
                    decide = 0;
                    bgm_no = BGM_STAGE1;
                }
            }
            break;

        case LOAD_STAGE:    //ロードステージ-------------------------
            wait_time_cnt++;
    
            //３秒待つ
            if(wait_time_cnt % 180 == 0){
                //プレイ中音楽再生
                if(!music_on){
                    PlayMusic( bgm_no , EXTENSION_MP3 , true);
                    music_on = true;
                }
                //エネミーの位置を欄外へ
                if(stage_num != STAGE5_IMG){
                    enemy[0] = -SELF_IMG_SIZE;
                    enemy[1] = -SELF_IMG_SIZE; //エネミー位置初期化*/
                }
                
                
                if(stage_num == STAGE1_IMG){
                    jiki_x = 32.0f;
                    jiki_y = 560.0f;
                }
                else if(stage_num == STAGE2_IMG){
                    jiki_x = 10.0f;
                    jiki_y = 30.0f;
                }
                else if(stage_num == STAGE_EX ){
                    jiki_x = 55.0f;
                    jiki_y = 105.0f;
                }
                else if(stage_num == STAGE4_IMG){
                    jiki_x = 64.0f;
                    jiki_y = 560.0f;
                }
                else if(stage_num == STAGE5_IMG){
                    jiki_x = 32.0f;
                    jiki_y = 560.0f;
                    
                    enemy[0] = (short)(SELF_IMG_SIZE*1.5);
                    enemy[1] = MAP_WIDTH - SELF_IMG_SIZE-1; //エネミー位置初期化*/
                }
                else if(stage_num == STAGE6_IMG){
                    jiki_x = 10.0f;
                    jiki_y = 10.0f;
                }
                
                s_ini = false;
                state = STAGE;
            }
            break;
            
        case STAGE:        //ステージ--------------------------------
            if(goal == 0){
                hantei();
                if(stop_time_switch == false){
                    [button[HALF_SPEED] addTarget:view action:@selector(onHalfSpeed) forControlEvents:UIControlEventTouchDown];
                    [button[TIME]       addTarget:view action:@selector(stop_time)   forControlEvents:UIControlEventTouchDown];
#if NO_DEATH_WALL
                    [debug_button       addTarget:view action:@selector(debug_btn)   forControlEvents:UIControlEventTouchDown];
#endif
                    Move();
                }
                else{
                    [button[TIME] addTarget:view action:@selector(stop_time) forControlEvents:UIControlEventTouchDown];
                }
            }
            else{
                if(!music_on){
                    PlayMusic( BGM_GOAL , EXTENSION_MP3 , false);
                    music_on = true;
                }
                wait_time_cnt++;
                if(wait_time_cnt % (60 * 10) == 0  || tap){
                    decide = 0;
                    end_show_score[ (int)( stage_num - STAGE1_IMG ) ] = (unsigned char)time_limit_val;
                    score += time_limit_val;
                    stage_num++;
                    bgm_no++;
                    if(stage_num > STAGE6_IMG ){
                        state = ENDING;
                    }
                    else{
                        state = LOAD_STAGE;
                    }
                    music_on = false;
                    [player stop];
                }
            }
            break;
            
        case DEATH: //ミス------------------------------------------
            if(death_flg == 0){
                if(wait_time_cnt % 60 == 0){
                    if( !music_on){
                        PlayMusic( BGM_LOSE , EXTENSION_MP3 , false);
                        music_on = true;
                    }
                    death_move();
                    if(jiki_y > 600){
                        wait_time_cnt = 1;
                        death_flg = 1;
                    }
                }
                else{
                    wait_time_cnt++;
                }
            }
            else{
                wait_time_cnt++;
                if(wait_time_cnt % 60 == 0){
                    state = DEATH2;
                }
            }
            break;
            
        case DEATH2:    //ミス画面--------------------------------------
            if(death_flg == 2){
                wait_time_cnt++;
                if(wait_time_cnt % 30 == 0){
                    life--;
                    if(life < 0){
                        state = GAMEOVER;
                    }
                    else{
                        state = LOAD_STAGE;
                    }
                }
            }
            else{
                dying();
            }
            break;
            
        case GAMEOVER:  //ゲームオーバー--------------------------------
            if(tap/*KEY(ENTER) || BUTTON_A*/){
                state = TITLE;
                decide = 0;
            }
            break;
            
        case ENDING:
            
        default:
            break;
    }
}

/*============================================================================
●描画処理(引数なし)
//戻り値：なし
============================================================================*/
void Draw(void)
{
    //タイトルの表示
    if(state == TITLE)
    {
        print_img(TOPTITLE , str_moji[TOPTITLE] , 0.0f , view.view.bounds.size.width/*800.0f*/ , 0.0f ,  /*view.view.bounds.size.height*/614.0f/**/ , 1.0f , 0.78125f);    //背景表示
        print_img(TITLE_MOJI , str_moji[TITLE_MOJI] , 0.0f , 450 , 75.0f ,  128.0f , 1.0f , 1.0f);    //背景表示
    }

    // Direct3Dによる描画の開始
	if(true/*SUCCEEDED(//g_pD3DDevice->BeginScene())*/)
	{
		// 頂点フォーマットの設定
		//g_pD3DDevice->SetFVF(FVF_VERTEX_2D);


        switch(state){
            
            //タイトル----------------------------------------------------------------------------------------------------------
            case TITLE:
                title();
                break;

            //ロードステージ--------------------------------------------------------------------------------------------------
            case LOAD_STAGE:
                stage_init();
                break;

            //ステージ-------------------------------------------------------------------------------------------------------------
            case STAGE:
                if(stage_num != STAGE_EX){
                    print_img(stage_num , str_moji[stage_num] , -map_scroll_x , 800.0f , -map_scroll_y ,  600.0f , 0.78125f , 0.5859375f);    //背景表示

                    if(stage_num == STAGE5_IMG){
                        print_img(FAIRY , str_moji[FAIRY] , enemy[1]-map_scroll_x , SELF_IMG_SIZE , enemy[0]-map_scroll_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //敵表示
                    }
                }
                else{
                    ending_scroll_y = 0;
                    LoadAndDrowDot();
                }
                if(goal == 1){
                    print_img(JIKI_GOAL , str_moji[JIKI_GOAL] , jiki_x-map_scroll_x , SELF_IMG_SIZE , jiki_y-map_scroll_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //自キャラ
                    print_str(FONT_TITLE , "GOAL!" , GOAL_POS , 1 , 0.5 , 0);
                }
                else{
                    chara_anime();
                }
                print_btn(BUTTON_SIZE , "↑" ,  UP      , 0.5 , 0.5 ,  0.5);  //自キャラ
                print_btn(BUTTON_SIZE , "←" , LEFT     , 0.5 , 0.5 ,  0.5);  //自キャラ
                print_btn(BUTTON_SIZE , "↓" , DOWN     , 0.5 , 0.5 ,  0.5);  //自キャラ
                print_btn(BUTTON_SIZE , "→" , RIGHT    , 0.5 , 0.5 ,  0.5);  //自キャラ
                print_btn(BUTTON_SIZE , "！" , TIME     , 0.5 , 0.5 ,  0.5);  //自キャラ
                if(!on_half_speed){
                    print_btn(BUTTON_SIZE , "○" ,HALF_SPEED, 0.5 , 0.5 ,  0.5);  //自キャラ
                }
                else{
                    print_btn(BUTTON_SIZE , "●" ,HALF_SPEED, 1 , 0 ,  0);  //自キャラ
                }
#if NO_DEATH_WALL
                debug_print();
#endif
                time_limit();
                break;
            
            //ミス------------------------------------------------------------------------------------------------------------------
            case DEATH:
                if(stage_num != STAGE_EX){
                    print_img(stage_num , str_moji[stage_num] , -map_scroll_x , 800.0f , -map_scroll_y ,  600.0f , 0.78125f , 0.5859375f);    //背景表示
                    
                    //敵表示
                    if(stage_num == STAGE5_IMG){
                        print_img(FAIRY , str_moji[FAIRY] , enemy[1]-map_scroll_x , SELF_IMG_SIZE , enemy[0]-map_scroll_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);
                    }
                }
                else{
                    ending_scroll_y = 0;
                    LoadAndDrowDot();
                }
                print_img(JIKI_DEATH , str_moji[JIKI_DEATH] , jiki_x-map_scroll_x , SELF_IMG_SIZE , jiki_y-map_scroll_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //自キャラ
                time_limit();
                break;

            //ミス２-----------------------------------------------------------------------------------------------------------------
            case DEATH2:
                if(death_flg != 2){
                    death2_screen();
                }
                else{
                    // バックバッファ＆Ｚバッファのクリア
                    uv.frame = view.view.bounds;
                    uv.backgroundColor = [UIColor colorWithRed:0.5f green:0.0f   blue:1.0f alpha:1.0f];
                    [view.view addSubview:uv];
                }
                break;
            
            //ゲームオーバー--------------------------------------------------------------------------------------------------------------
            case GAMEOVER:
                uv.frame = view.view.bounds;
                uv.backgroundColor = [UIColor colorWithRed:0.5f green:0.0f   blue:1.0f alpha:1.0f];
                [view.view addSubview:uv];

                print_img(JIKI_DEATH , str_moji[JIKI_DEATH] , 384.0f , SELF_IMG_SIZE , 240.0f ,  SELF_IMG_SIZE, 1.0f , 1.0f);
                print_str(FONT_NORMAL , "GAMEOVER" , DIED_POS , 1,1,1);
                break;
                
            //エンディング-----------------------------------------------------------------------------------------------------------------
            case ENDING:
            
                if(!music_on){
                    show_score_cnt = 0;
                    PlayMusic( BGM_ENDING , EXTENSION_MP3 , false);
                    ending_scroll_y = 500;
                    stage_num = STAGE1_IMG;
                    music_on = true;
                    wait_time_cnt = 1;
                    sound_on = false;
                    scroll_speedup = false;
                    scroll_speed = 1;
                }
                map_scroll_x = 0;
                map_scroll_y = 0;
                /* バックバッファ＆Ｚバッファのクリア*/
                uv.frame = view.view.bounds;
                uv.backgroundColor = [UIColor colorWithRed:1.0f green:0.8f   blue:0.8f alpha:1.0f];
                [view.view addSubview:uv];

                if(stage_num == STAGE1_IMG){
                    print_img(stage_num , str_moji[stage_num] , 0.0f , 320.0f , ending_scroll_y ,  240.0f , 0.78125f , 0.5859375f);    //背景表示
                    sprintf(t_szbuf,"制作スタッフたち");
                    rect[STUFFROLL1].x1=WINDOW_WIDTH/2-FONT_NORMAL*strlen(t_szbuf)/2/3;
                    print_str(FONT_NORMAL , t_szbuf , STUFFROLL1 , 1,0,1);

                    sprintf(t_szbuf,"レッドフォード");
                    rect[STUFFROLL2].x1=WINDOW_WIDTH/2-FONT_NORMAL*strlen(t_szbuf)/2/3;
                }
                if(stage_num == STAGE2_IMG){
                    print_img(stage_num , str_moji[stage_num] , 0.0f , 320.0f , ending_scroll_y ,  240.0f , 0.78125f , 0.5859375f);    //背景表示
                    sprintf(t_szbuf,"企画・立案・スペシャルアドバイザー");
                    rect[STUFFROLL1].x1=WINDOW_WIDTH/2-FONT_NORMAL*strlen(t_szbuf)/2/3;
                    print_str(FONT_NORMAL , "企画・立案・スペシャルアドバイザー" , STUFFROLL1 , 1,0,1);
                    print_str(FONT_NORMAL , "レッドフォード" , STUFFROLL2 , 1,0,1);
                }
                if(stage_num == STAGE_EX){
                    LoadAndDrowDot();
                    sprintf(t_szbuf,"立案・ステージ制作");
                    rect[STUFFROLL1].x1=WINDOW_WIDTH/2-FONT_NORMAL*strlen(t_szbuf)/2/3;
                    print_str(FONT_NORMAL , "立案・ステージ制作" , STUFFROLL1 , 1,0,1);
                    print_str(FONT_NORMAL , "レッドフォード" , STUFFROLL2 , 1,0,1);
                }
                if(stage_num == STAGE4_IMG){
                    print_img(stage_num , str_moji[stage_num] , 0.0f , 320.0f , ending_scroll_y ,  240.0f , 0.78125f , 0.5859375f);    //背景表示
                    sprintf(t_szbuf,"ステージ制作・イラスト");
                    rect[STUFFROLL1].x1=WINDOW_WIDTH/2-FONT_NORMAL*strlen(t_szbuf)/2/3;
                    print_str(FONT_NORMAL , "ステージ制作・イラスト" , STUFFROLL1 , 1,0,1);
                    print_str(FONT_NORMAL , "レッドフォード" , STUFFROLL2 , 1,0,1);
                }
                if(stage_num == STAGE5_IMG){
                    print_img(stage_num , str_moji[stage_num] , 0.0f , 320.0f , ending_scroll_y ,  240.0f , 0.78125f , 0.5859375f);    //背景表示
                    print_img(FAIRY , str_moji[FAIRY] , 750.0f , SELF_IMG_SIZE , (float)(50+ending_scroll_y) ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //敵表示
                    sprintf(t_szbuf,"プログラム・サウンド");
                    rect[STUFFROLL1].x1=WINDOW_WIDTH/2-FONT_NORMAL*strlen(t_szbuf)/2/3;
                    print_str(FONT_NORMAL , "プログラム・サウンド" , STUFFROLL1 , 1,0,1);
                    print_str(FONT_NORMAL , "レッドフォード" , STUFFROLL2 , 1,0,1);
                }
                if(stage_num == STAGE6_IMG){
                    print_img(stage_num , str_moji[stage_num] , 0.0f , 320.0f , ending_scroll_y ,  240.0f , 0.78125f , 0.5859375f);    //背景表示
                    sprintf(t_szbuf,"Presented by ...");
                    rect[STUFFROLL1].x1=WINDOW_WIDTH/2-FONT_NORMAL*strlen(t_szbuf)/2/3;
                    print_str(FONT_NORMAL , "Presented by ..." , STUFFROLL1 , 1,0,1);
                    sprintf(t_szbuf,"Profire");
                    rect[STUFFROLL2].x1=WINDOW_WIDTH/2-FONT_NORMAL*strlen(t_szbuf)/2/3;
                    print_str(FONT_NORMAL , "Profire" , STUFFROLL2 , 1,0,1);
                }

                if(ending_scroll_y < -250){
                    stage_num++;
                    ending_scroll_y = 500;
                }
                else{
                    if(stage_num <= STAGE6_IMG){
                        ending_scroll_y-=scroll_speed;
                        if(scroll_speedup != true){
                            if(tap/*KEY(ENTER) || BUTTON_A*/){
                                scroll_speed *= 10;
                                scroll_speedup = true;
                            }
                        }
                        else{
                            if(tap/*KEY(ENTER) || BUTTON_A*/){
                                scroll_speed /= 10;
                                scroll_speedup = false;
                            }
                        }
                    }
                    else{
                    
                        if(show_score_cnt <= 6){
                            wait_time_cnt++;
                            if(wait_time_cnt % 60 == 0){
                                show_score_cnt++;
                                wait_time_cnt = 1;
                            }
                        }
                        if(show_score_cnt >= 1){
                            sprintf(t_szbuf , "STAGE%d SCORE：%d" , 1 , end_show_score[1-1]);
                            print_str(FONT_NORMAL , t_szbuf , SHOWSCORE1_POS , 1,0,1);
                        }
                        if(show_score_cnt >= 2){
                            sprintf(t_szbuf , "STAGE%d SCORE：%d" , 2 , end_show_score[2-1]);
                            print_str(FONT_NORMAL , t_szbuf , SHOWSCORE2_POS , 1,0,1);
                        }
                        if(show_score_cnt >= 3){
                            sprintf(t_szbuf , "STAGE%d SCORE：%d" , 3 , end_show_score[3-1]);
                            print_str(FONT_NORMAL , t_szbuf , SHOWSCORE3_POS , 1,0,1);
                        }
                        if(show_score_cnt >= 4){
                            sprintf(t_szbuf , "STAGE%d SCORE：%d" , 4 , end_show_score[4-1]);
                            print_str(FONT_NORMAL , t_szbuf , SHOWSCORE4_POS , 1,0,1);
                        }
                        if(show_score_cnt >= 5){
                            sprintf(t_szbuf , "STAGE%d SCORE：%d" , 5 , end_show_score[5-1]);
                            print_str(FONT_NORMAL , t_szbuf , SHOWSCORE5_POS , 1,0,1);
                        }
                        if(show_score_cnt >= 6){
                            sprintf(t_szbuf , "STAGE%d SCORE：%d" , 6 , end_show_score[6-1]);
                            print_str(FONT_NORMAL , t_szbuf , SHOWSCORE6_POS , 1,0,1);
                        }
                        
                        if(show_score_cnt == 7){
                            wait_time_cnt++;
                            if(wait_time_cnt % 60 == 0){
                                show_score_cnt++;
                                wait_time_cnt = 1;
                            }
                        }
                        if(show_score_cnt >= 8){
                            print_str(FONT_NORMAL , "SUMSCORE：" , SUMSCORE_POS , 1,0,1);
                            wait_time_cnt++;
                            if(wait_time_cnt % 120 == 0){
                                show_score_cnt++;
                                wait_time_cnt = 1;
                            }
                        }
                        if(show_score_cnt >= 9){
                            if(sound_on == false){
                                PlayMusic( SE_ENDSCORE , EXTENSION_WAV , false);
                                sound_on = true;
                            }
                            sprintf(t_szbuf , "%d" , score);
                            print_str(FONT_NORMAL , t_szbuf , SUMSCORENUM_POS , 1 , 0.1 , 0.1);
                            wait_time_cnt++;
                            if(wait_time_cnt % 180 == 0){
                                show_score_cnt++;
                                wait_time_cnt = 1;
                            }
                        }
                        if(show_score_cnt >=10 ){
                            print_str(FONT_NORMAL , "YOU WON！"         , YOUWON_POS       , 0  ,0  ,1);
                            print_str(FONT_NORMAL , "CONGRATULATIONS☆" , CONGRATULATE_POS , 1  ,0.5,0);
                            print_str(FONT_NORMAL , "PLEASE TAP"        , ENDPRESS_POS     , 1  ,0  ,0);
                            
                            if(tap/*KEY(ENTER) || BUTTON_A*/){
                                StopMusic(BGM_ENDING);
                                music_on = false;
                                state = TITLE;
                            }
                        }
                    }
                }
                break;
                
            //デフォルト--------------------------------------------------------------------------------------------------------------------
            default:
                break;
        }
        // Direct3Dによる描画の終了
		//g_pD3DDevice->EndScene();
	}
	// バックバッファとフロントバッファの入れ替え
	//g_pD3DDevice->Present(NULL, NULL, NULL, NULL);
}
#if 0
/*
 #Region
//表示系の関数は以下====================================================================================================
 #endif
*/
#endif
/*============================================================================
●文字の表示(フォント大きさ , 文字内容 , 表示位置XY表示範囲XY , 色R,G,B)
//戻り値：なし
============================================================================*/
void print_str(int font_size , char* str , int POS_NUM , float colorR , float colorG , float colorB){

    rect[POS_NUM].width = font_size*strlen(str);
    rect[POS_NUM].height = font_size;

    label[POS_NUM].text =  [NSString stringWithCString: str encoding:NSUTF8StringEncoding];;
    label[POS_NUM].frame = CGRectMake(rect[POS_NUM].x1, rect[POS_NUM].y1, rect[POS_NUM].width, rect[POS_NUM].height);

    label[POS_NUM].textColor = [[UIColor alloc]initWithRed:colorR green:colorG   blue:colorB alpha:1.0];
#if XCODE_42
    label[POS_NUM].textAlignment = UITextAlignmentLeft;
    label[POS_NUM].font = [UIFont systemFontOfSize:font_size];
#else
    label[POS_NUM].textAlignment = NSTextAlignmentLeft;
    label[POS_NUM].font = [UIFont fontWithName:@"AppleGothic" size:font_size];
#endif
    label[POS_NUM].hidden = false;
    label[POS_NUM].opaque = NO;
    label[POS_NUM].backgroundColor = [UIColor colorWithWhite:1.0f alpha:0.0f];
    [view.view addSubview:label[POS_NUM]];
    
}

/*============================================================================
●文字の表示(フォント大きさ , 文字内容 , 表示位置XY表示範囲XY , 色R,G,B)
//戻り値：なし
============================================================================*/
void print_btn(int font_size , char* str , int pos_num , float colorR , float colorG , float colorB){

    // フォント
    [button[pos_num].titleLabel setFont:[UIFont systemFontOfSize:font_size]];

    // 文字
    [button[pos_num] setTitle:[NSString stringWithCString: str encoding:NSUTF8StringEncoding] forState:UIControlStateNormal];

    // 位置と大きさ
    rect_btn[pos_num].width = font_size;//*strlen(str);
    rect_btn[pos_num].height = font_size;
    button[pos_num].frame = CGRectMake(rect_btn[pos_num].x1, rect_btn[pos_num].y1, rect_btn[pos_num].width, rect_btn[pos_num].height);

    // RGB
    [button[pos_num] setTitleColor:[[UIColor alloc]initWithRed:colorR green:colorG   blue:colorB alpha:0.5]  forState:UIControlStateNormal];

    // 表示
    button[pos_num].hidden = false;
    button[pos_num].opaque = NO;
    button[pos_num].backgroundColor = [UIColor colorWithWhite:1.0f alpha:0.0f];
    [view.view addSubview:button[pos_num]];
}

/*============================================================================
●画像の表示(画像番号 , 画像の名前 , 表示位置X , 画像の大きさX , 表示位置Y , 画像の大きさY , 画像の大きさは、画面の大きさを兼ねる2のべき乗の何割かXY)
//戻り値：なし
============================================================================*/
void print_img(short num , NSString *name , float place_x , float xdif , float place_y , float ydif , float bmp_ratio_x , float bmp_ratio_y){

    // 宣言
    UIImage *img;   // イメージデータ

    // 初期化
    img = [UIImage imageNamed:name];
    
    // 透過の有効化
    g_pTexture_array[num].opaque = NO;

    // 頂点カラー・αチャンネルの設定
    g_pTexture_array[num].backgroundColor = [UIColor colorWithRed:1.0f green:0.0f blue:1.0f alpha:0.0f];
    // Imageだと意味ないみたい　残念すぎる
    
    // ファイル名から読み込み
    if(g_pTexture_array[num] == NULL){
        g_pTexture_array[num] = [[UIImageView alloc] initWithImage:img];
    }
    // Xサイズ未設定の場合は画像に準拠
    if( xdif == 0){
        xdif =  [img size].width;
    }
    if( ydif == 0){
        ydif =  [img size].height;
    }
    // 頂点座標の設定
    g_pTexture_array[num].frame = CGRectMake(place_x, place_y, xdif, ydif);

    //表示
    [view.view addSubview:g_pTexture_array[num]];

}

#if 0
/*
 #Region
//以下は自作の処理関数====================================================================================================
 #endif
*/
#endif

/*============================================================================
●タイトル(引数なし)
//戻り値：なし
============================================================================*/
void title(void){
                
    //注釈表示
    word = @"PLEASE TAP";
    str2 = (char*)[word UTF8String];
    sprintf(t_szbuf , "%s" , str2 );
                
    if(decide != 1){
        //Press Enter
        if(cntFrame / 60 % 2 == 0){
            print_str(FONT_NORMAL , t_szbuf , PRESSENTER_POS , 1,0,0);
        }
        else{
            label[TITLE_POS].hidden = true;

        }
    }
    //コピーライト表示
    rect[COPYRIGHT_POS].y1 = WINDOW_HEIGHT - FONT_NORMAL;
    print_str(FONT_NORMAL , "(c)Profire" , COPYRIGHT_POS , 1,0,0);
    
    if(hiscore < score){
        hiscore = score;
    }
    sprintf(t_szbuf , "HISCORE:%d" , hiscore );
    print_str(FONT_NORMAL , t_szbuf , HISCORE_POS , 1,0,0);
    

}

/*============================================================================
●決定(引数なし)
//戻り値：なし
============================================================================*/
void PlayStart(void){
    //決定
    if( tap/*KEY(ENTER) || BUTTON_A*/ ){

        decide = 1;
        wait_time_cnt = 1;

        //音鳴らし
        StopMusic( BGM_TITLE );   //ストップミュージック
        music_on = false;
        PlayMusic( SE_DECIDE , EXTENSION_WAV , false); //効果音再生

    }
    //他ボタン
    else{
        //特になし
    }

}

/*============================================================================
●プレイヤーの移動(引数なし)
//戻り値：なし
============================================================================*/
void Move(){

    //↑
    if(up_move/*g_keyState[DIK_UP] & 0x80 || g_joyState[0].lY < (-MEMORY/2)*/
    || button[UP].state == UIControlStateHighlighted
    ){
        up_move = true;
        SetMoveSpeed();
        prev_ground_slide = 0;
        prev_ground_slide_LR = 0;
        //上外超えてない
        if(MOVABLE_BAR < jiki_y){
            jiki_y -= move_speed;
        }
    }
    //↓
    else if(down_move/*g_keyState[DIK_DOWN] & 0x80 || g_joyState[0].lY > (MEMORY/2)*/
    || button[DOWN].state == UIControlStateHighlighted
    ){
        down_move = true;
        SetMoveSpeed();
        prev_ground_slide = 0;
        prev_ground_slide_LR = 0;
        //下外超えてない
        if(jiki_y < MOVABLE_UNDER){
            jiki_y += move_speed;
        }
    }
    //離した時
    else{
        glide();
    }

    //←
    if(left_move/*g_keyState[DIK_LEFT] & 0x80 || g_joyState[0].lX < (-MEMORY/2)*/
    || button[LEFT].state == UIControlStateHighlighted
    ){
        left_move = true;
        SetMoveSpeed();
        prev_ground_slide = 0;
        prev_ground_slide_LR = 0;
        //左外超えてない
        if(MOVABLE_LEFT < jiki_x){
            jiki_x -= move_speed_line;
        }
    }
    //→
    else if(right_move/*g_keyState[DIK_RIGHT] & 0x80 || g_joyState[0].lX > (MEMORY/2)*/
    || button[RIGHT].state == UIControlStateHighlighted
    ){
        right_move = true;
        SetMoveSpeed();
        prev_ground_slide = 0;
        prev_ground_slide_LR = 0;
        //右外超えてない
        if(jiki_x < MOVABLE_RIGHT){
            jiki_x += move_speed_line;
        }
    }
    else{
        glide_LR();
    }    

    //マウス(マウスが自機に重なった時クリックしていたら、自機がマウスに追従する)
    if(jiki_y <= mouse_pos_y  && mouse_pos_y <= jiki_y + SELF_IMG_SIZE      //マウス座標Yが自機(縦)の範囲内
    && jiki_x <= mouse_pos_x  && mouse_pos_x <= jiki_x + SELF_IMG_SIZE){    //マウス座標Xが自機(横)の範囲内
        //クリックしていた時
        if(tap/*g_mouseState.rgbButtons[0] & 0x80*/){
            jiki_y = (float)(mouse_pos_y-(SELF_IMG_SIZE/2));
            jiki_x = (float)(mouse_pos_x-(SELF_IMG_SIZE/2));
        }
    }
}
/*============================================================================
●PAUSEする(引数なし)
//戻り値：なし
============================================================================*/
-(void)stop_time{
    if(stop_time_switch == false && state == STAGE && goal == 0){
        stop_time_switch = true;
    }
    else{
        stop_time_switch = false;
    }
}

/*============================================================================
●縦滑りの処理(引数なし)
//戻り値：なし
============================================================================*/
void glide(void){
    //画面内
    if(MOVABLE_BAR < jiki_y && jiki_y < MOVABLE_UNDER){
        //スピードが残ってる
        if(move_speed < -1 || 1 < move_speed){
            //上を押してた。今は上を押してない
            if( //(!(g_keyState[DIK_UP] & 0x80) && g_keyStatePrev[DIK_UP] & 0x80 )                //キーボード対応
            //|| ( (g_joyState[0].lY > (-MEMORY/2)) && g_joyStatePrev[0].lY < (-MEMORY/2) ) )     //パッド対応
              (old_up_move && !up_move)){
                //上方向滑りスイッチオン
                //if(prev_ground_slide != 1)
                {
                    prev_ground_slide = 1;
                    //マイナス絶対値
                    if(move_speed > 0 ){
                        move_speed *= -1;
                    }
                }
            }
            //下を押してた。今は下を押してない。
            else if( //(!(g_keyState[DIK_DOWN] & 0x80) && g_keyStatePrev[DIK_DOWN] & 0x80)        //キーボード対応
                //|| ( (g_joyState[0].lY < (MEMORY/2)) && g_joyStatePrev[0].lY > (MEMORY/2) ) ){  //パッド対応
                (old_down_move && !down_move)){
                //下方向滑りスイッチオン
                if(prev_ground_slide != 2){
                    prev_ground_slide = 2;
                }
            }
            
            //上滑り能力減少
            if(prev_ground_slide == 1){
                move_speed += 0.1f;
            }
            //下滑り能力減少
            else if(prev_ground_slide == 2){
                move_speed -= 0.1f;
            }
            //滑り中
            if(prev_ground_slide != 0){
                jiki_y += move_speed;   //滑り
            }
        }
        //滑り止まった(というか、滑り能力が、-0.9～+0.9になった時)
        else{
            prev_ground_slide = 0;
            move_speed = 0;
        }
    }
}

/*============================================================================
●横滑りの処理(引数なし)
//戻り値：なし
============================================================================*/
void glide_LR(void){
    //画面内
    if(MOVABLE_LEFT < jiki_x && jiki_x < MOVABLE_RIGHT){
        //スピードが残ってる
        if(move_speed_line < -1 || 1 < move_speed_line){
            //左を押してた。今は左を押してない
            if( //(!(g_keyState[DIK_LEFT] & 0x80) && g_keyStatePrev[DIK_LEFT] & 0x80 )                //キーボード対応
            //|| ( (g_joyState[0].lX > (-MEMORY/2)) && g_joyStatePrev[0].lX < (-MEMORY/2) ) ){    //パッド対応
            (old_left_move && !left_move)){
                //上方向滑りスイッチオン
                //if(prev_ground_slide != 1)
                {
                    prev_ground_slide_LR = 1;
                    //マイナス絶対値
                    if(move_speed_line > 0 ){
                        move_speed_line *= -1;
                    }
                }
            }
            //右を押してた。今は右を押してない。
            else if( //(!(g_keyState[DIK_RIGHT] & 0x80) && g_keyStatePrev[DIK_RIGHT] & 0x80)        //キーボード対応
                //|| ( (g_joyState[0].lX < (MEMORY/2)) && g_joyStatePrev[0].lX > (MEMORY/2) ) ){  //パッド対応
                (old_right_move && !right_move)){
                //下方向滑りスイッチオン
                if(prev_ground_slide_LR != 2){
                    prev_ground_slide_LR = 2;
                }
            }
            
            //上滑り能力減少
            if(prev_ground_slide_LR == 1){
                move_speed_line += 0.1f;
            }
            //下滑り能力減少
            else if(prev_ground_slide_LR == 2){
                move_speed_line -= 0.1f;
            }
            //滑り中
            if(prev_ground_slide_LR != 0){
                jiki_x += move_speed_line;   //滑り
            }
        }
        //滑り止まった(というか、滑り能力が、-0.9～+0.9になった時)
        else{
            prev_ground_slide_LR = 0;
            move_speed_line = 0;
        }
    }
}

/*============================================================================
●当たり判定(引数なし)
//戻り値：なし
============================================================================*/
void hantei(void){

    if(stage_num == STAGE5_IMG){
        enemy[1] += enemy_speed;
        if(enemy[1] < SELF_IMG_SIZE){
            enemy_speed *= -1;
        }
        if(enemy[1] > MAP_WIDTH - SELF_IMG_SIZE){
            enemy_speed *= -1;
        }
    }
    for(int hantei_y = (int)jiki_y+5; hantei_y < (jiki_y+SELF_IMG_SIZE-5); hantei_y++){
        for(int hantei_x = (int)jiki_x+5; hantei_x < (jiki_x+SELF_IMG_SIZE-5); hantei_x++){
            if(stage_num != STAGE_EX){
                //死亡判定
                if(stage[stage_num-STAGE1_IMG][hantei_y/2][hantei_x/2] == 0){
                    if(no_death_wall == false){
                        state = DEATH;
                    }
                }
                //ゴール判定
                else if(stage[stage_num-STAGE1_IMG][hantei_y/2][hantei_x/2] == 2){
                    goal = 1;
                }
                //ステージ５は敵がいる
                if(stage_num == STAGE5_IMG){
                    if(enemy[0] < hantei_y && hantei_y < enemy[0]+SELF_IMG_SIZE
                    && enemy[1] < hantei_x && hantei_x < enemy[1]+SELF_IMG_SIZE
                    ){
                        state = DEATH;
                    }
                }/**/
            }
            //ステージ３は特殊
            else{
                static int length = 0;
                static int lx1,lwidth,ly1,lheight,dx1,dwidth,dy1,dheight,rx1,rwidth,ry1,rheight;
                if(length == 0){
                    //外壁設定
                    length = BLOCK_SIZE*(mapsize+2);

                    //外壁（左）
                    lx1 = 0;
                    lwidth = BLOCK_SIZE;
                    ly1 = 0;
                    lheight = length;

                    //外壁（下）
                    dx1 = 0;
                    dwidth = length;
                    dy1 = BLOCK_SIZE*mapsize;
                    dheight = BLOCK_SIZE+dy1;

                    //外壁（右）
                    rx1 = BLOCK_SIZE*(mapsize+1);
                    rwidth = BLOCK_SIZE+rx1;
                    ry1 = 0;
                    rheight = length;
                }
                if( *(map+((int)hantei_y/BLOCK_SIZE)*mapsize+( ( (int)hantei_x)/BLOCK_SIZE)-1 ) == 0
                ||( lx1 < hantei_x && hantei_x < lwidth && ly1 < hantei_y && hantei_y < lheight )  //左側の壁
                ||( dx1 < hantei_x && hantei_x < dwidth && dy1 < hantei_y && hantei_y < dheight )  //下側の壁
                ||( rx1 < hantei_x && hantei_x < rwidth && ry1 < hantei_y && hantei_y < rheight )  //右側の壁
                ){
                    if(no_death_wall == false){
                        state = DEATH;
                    }
                }
                else if(*(map+((int)hantei_y/BLOCK_SIZE)*mapsize+( ( (int)hantei_x) /BLOCK_SIZE)-1 ) == 2){   //マイナスで右(プラス)へ
                    goal = 1;
                }
            }
        }
    }
    
    
    if(state == DEATH || goal == 1){
        StopMusic( bgm_no );
        wait_time_cnt = 1;
        music_on = false;
    }
}

/*============================================================================
●ミス時の動き(引数なし)
//戻り値：なし
============================================================================*/
void death_move(void){
    if(fall_switch == 0){
        death_move_speed += 0.5;
        if(death_move_speed >= 10){
            fall_switch = 1;
        }
        jiki_y -= death_move_speed;
    }
    else{
        if(death_move_speed >= -10){
            death_move_speed -= 0.5;
        }
        jiki_y -= death_move_speed;
    }
}

/*============================================================================
●スピード設定(引数なし)
//戻り値：なし
============================================================================*/
void SetMoveSpeed(void){
    if(button[UP].state    == UIControlStateHighlighted
    || button[LEFT].state  == UIControlStateHighlighted
    || button[DOWN].state  == UIControlStateHighlighted
    || button[RIGHT].state == UIControlStateHighlighted
    ){
        move_speed = SPEED;     //移動速度
        move_speed_line = SPEED;     //移動速度
    }
    //ダッシュ
    if(on_half_speed){
        move_speed /= 2;
        move_speed_line /= 2;
    }

}

/*============================================================================
●ハーフスピード設定(引数なし)
//戻り値：なし
============================================================================*/
-(void)onHalfSpeed{
    
    if(on_half_speed == false){
        on_half_speed = true;
    }
    else{
        on_half_speed = false;
    }

}


/*============================================================================
●プレイ前初期化(引数なし)
//戻り値：なし
============================================================================*/
void stage_init(void){
    
    //ロードがまだ終わってない
    if(s_ini != true){
        uv.frame = view.view.bounds;
        uv.backgroundColor = [UIColor colorWithRed:0.5f green:0.0f   blue:1.0f alpha:1.0f];
        [view.view addSubview:uv];

        print_img(JIKI1 , str_moji[JIKI1] , view.view.bounds.size.width/2-SELF_IMG_SIZE , 0 , 200.0f ,  0, 1.0f , 1.0f);

        sprintf(t_szbuf , "x %d",life);/**/
        print_str(FONT_NORMAL , t_szbuf , REMAIN_POS , 1,1,1);

        sprintf(t_szbuf , "STAGE %d",stage_num-STAGE1_IMG+1);/**/
        print_str(FONT_NORMAL , t_szbuf , STAGE_POS , 1,1,1);

        print_str(FONT_STGLD , "SWIPE or"                , LOADING_POS     , 1 , 1 , 1 );
        print_str(FONT_STGLD , "PUSH ↑/←/↓/→ BUTTON!", WAITFEWSEC_POS  , 1 , 1 , 1 );

        //print_str(FONT_STGLD , "The movement speed is reduced by half"       , HELPHINT_POS1   , 1 , 1 , 1 );
        //print_str(FONT_STGLD , "  when doing while pushing the [SPACE KEY]!" , HELPHINT_POS2   , 1 , 1 , 1 );

        //print_str(FONT_STGLD , "  Use [MOUSE] , too!"                        , HELPHINT_POS2_1 , 1 , 1 , 1 );
        //print_str(FONT_STGLD , "  [CLICK] drag the character and move it!"   , HELPHINT_POS2_2 , 1 , 1 , 1 );

        wait_time_cnt = 1;
        s_ini = true;   //ロードしました

        death_flg = 0;
        fall_switch = 0;
        death_move_speed = 0;
        goal = 0;
        prev_ground_slide = 0;         //前入力の残りで移動滑り
        prev_ground_slide_LR = 0;      //前入力の残り(左右)
        
        if(stage_num == STAGE6_IMG){
            time_limit_val = 150;
        }
        else{
            time_limit_val = 100;
        }
    }

}

/*============================================================================
●ミス時画面(引数なし)
//戻り値：なし
============================================================================*/
void death2_screen(void){
    uv.frame = view.view.bounds;
    uv.backgroundColor = [UIColor colorWithRed:0.5f green:0.0f   blue:1.0f alpha:1.0f];
    [view.view addSubview:uv];

    print_img(JIKI_DEATH , str_moji[JIKI_DEATH] , view.view.bounds.size.width/2 - SELF_IMG_SIZE/2 , 0 , 180.0f ,  0, 1.0f , 1.0f);

    print_str(FONT_NORMAL , "YOU DIED"   , DIED_POS       , 1,1,1);
    print_str(FONT_STGLD  , "PLEASE TAP" , DIED_ENTER_POS , 1,1,1);


}

/*============================================================================
●ミス中(引数なし)
//戻り値：なし
============================================================================*/
void dying(void){
    if(death_flg != 2){
        if(tap/*KEY(ENTER) || BUTTON_A*/){
            wait_time_cnt = 1;
            StopMusic( BGM_LOSE );   //ストップミュージック
            music_on = false;
            death_flg = 2;
        }
    }
}

/*============================================================================
●デバッグ表示用(引数なし)
//戻り値：なし
============================================================================*/
void debug_print(void){
    
    // フォント
    [debug_button.titleLabel setFont:[UIFont systemFontOfSize:32]];

    // 位置と大きさ
    debug_button.frame = CGRectMake(WINDOW_WIDTH-64 ,WINDOW_HEIGHT-100, 64, 32);

    // RGB
    if(no_death_wall == false){
        // 文字
        [debug_button setTitle:[NSString stringWithCString: "？" encoding:NSUTF8StringEncoding] forState:UIControlStateNormal];
        [debug_button setTitleColor:[[UIColor alloc]initWithRed:1 green:0   blue:0 alpha:0.5]  forState:UIControlStateNormal];
    }
    else{
        [debug_button setTitle:[NSString stringWithCString: "無敵" encoding:NSUTF8StringEncoding] forState:UIControlStateNormal];
        [debug_button setTitleColor:[[UIColor alloc]initWithRed:0 green:0   blue:1 alpha:0.5]  forState:UIControlStateNormal];
    }
    // 表示
    debug_button.hidden = false;
    debug_button.opaque = NO;
    debug_button.backgroundColor = [UIColor colorWithWhite:1.0f alpha:0.0f];
    [view.view addSubview:debug_button];

    //sprintf(t_szbuf , "%d",(int)jiki_x);/**/
    
}
/*============================================================================
●デバッグ効果(引数なし)
//戻り値：なし
============================================================================*/
-(void)debug_btn{
    if(no_death_wall == false){
        no_death_wall = true;
    }
    else{
        no_death_wall = false;
    }

}

/*============================================================================
●キャラのアニメ(引数なし)
//戻り値：なし
============================================================================*/
void chara_anime(void){
    static int anime_flg = 0;
    
    if(cntFrame % BLINK_FRAME == 0
    && stop_time_switch == true){
        cntFrame++;
    }
    
    switch(anime_flg){
        case 0:
            print_img(JIKI1 , str_moji[JIKI1] , jiki_x-map_scroll_x , SELF_IMG_SIZE , jiki_y-map_scroll_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //自キャラ
            if(cntFrame % BLINK_FRAME == 0){
                anime_flg = 1;
            }
            break;

        case 1:
            print_img(JIKI2 , str_moji[JIKI2] , jiki_x-map_scroll_x , SELF_IMG_SIZE , jiki_y-map_scroll_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //自キャラ
            if(cntFrame % (BLINK_FRAME) == 0){
                anime_flg = 2;
            }
            break;

        case 2:
            print_img(JIKI3 , str_moji[JIKI3] , jiki_x-map_scroll_x , SELF_IMG_SIZE , jiki_y-map_scroll_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //自キャラ
            if(cntFrame % BLINK_FRAME == 0){
                anime_flg = 3;
            }
            break;

        case 3:
            print_img(JIKI4 , str_moji[JIKI4] , jiki_x-map_scroll_x , SELF_IMG_SIZE , jiki_y-map_scroll_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //自キャラ
            if(cntFrame % BLINK_FRAME == 0){
                anime_flg = 4;
            }
            break;

        case 4:
            print_img(JIKI5 , str_moji[JIKI5] , jiki_x-map_scroll_x , SELF_IMG_SIZE , jiki_y-map_scroll_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //自キャラ
            if(cntFrame % BLINK_FRAME == 0){
                anime_flg = 5;
            }
            break;

        case 5:
            print_img(JIKI4 , str_moji[JIKI4] , jiki_x-map_scroll_x , SELF_IMG_SIZE , jiki_y-map_scroll_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //自キャラ
            if(cntFrame % BLINK_FRAME == 0){
                anime_flg = 6;
            }
            break;

        case 6:
            print_img(JIKI3 , str_moji[JIKI3] , jiki_x-map_scroll_x , SELF_IMG_SIZE , jiki_y-map_scroll_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //自キャラ
            if(cntFrame % BLINK_FRAME == 0){
                anime_flg = 7;
            }
            break;

        case 7:
            print_img(JIKI2 , str_moji[JIKI2] , jiki_x-map_scroll_x , SELF_IMG_SIZE , jiki_y-map_scroll_y ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //自キャラ
            if(cntFrame % BLINK_FRAME == 0){
                anime_flg = 0;
            }
            break;

        default:
            break;
    }
}

/*============================================================================
●制限時間(引数なし)
//戻り値：なし
============================================================================*/
void time_limit(void){
    if(time_limit_val > 0
    && goal != 1
    && state != DEATH){
        if(cntFrame % 60 == 0){
            time_limit_val--;
        }
    }
    else{
        if(state == STAGE
        && goal != 1){
            state = DEATH;
            StopMusic( bgm_no );
            music_on = false;
            wait_time_cnt = 1;
        }
    }
    print_img(JIKI0 , str_moji[JIKI0] , 0 , SELF_IMG_SIZE , 0 ,  SELF_IMG_SIZE , 1.0f , 1.0f);  //自キャラ
    sprintf(t_szbuf , "x%d　　SCORE:%03d　　TIME:%03d" , life , score , time_limit_val);/**/
    print_str(FONT_NORMAL , t_szbuf , TIMELIMIT_POS , 0  ,1  ,0);

    
    if(stop_time_switch == true){
        print_str(FONT_NORMAL , "PAUSE" , STOP_TIME_POS , 1  ,0.8  ,0);
    }
    
}

/*============================================================================
●ステージチップのブロック表示(引数なし)
//戻り値：なし
============================================================================*/
void LoadAndDrowDot(void){
    int maptip;
    float block_size = BLOCK_SIZE;
    float map_height = MAP_HEIGHT; //ending用
    if(state == ENDING){
        block_size *= 0.4;
        map_height *= 0.4;
    }
    maptip_num = 0;
    //1回こっきり用
    if(write_screen == 0){

        //画面縦分全て
        for(int stage_y_dot_num = 0; stage_y_dot_num < mapsize ; stage_y_dot_num++){
            hanni.y1 = block_size*stage_y_dot_num  - map_scroll_y + ending_scroll_y;
            hanni.height = block_size;

            //画面横分全て
            for(int stage_x_dot_num = 0; stage_x_dot_num < mapsize ; stage_x_dot_num++){
                hanni.x1 = block_size*(stage_x_dot_num+1) - map_scroll_x;
                hanni.width = block_size;
                maptip = *(map + stage_y_dot_num * mapsize + stage_x_dot_num);  //マップ上のデータをコピー
                
                //壁(黒)
                if(mapDat[maptip] == 0){
                    stage_ex[maptip_num].backgroundColor = [UIColor colorWithRed:0.0f green:0.0f   blue:0.0f alpha:1.0f];
                    drawMap();
                }
                //何もない(白)
                else if(mapDat[maptip] == 255){
                    stage_ex[maptip_num].backgroundColor = [UIColor colorWithRed:1.0f green:1.0f   blue:1.0f alpha:1.0f];
                    drawMap();
                }
                //ゴール(赤)
                else if(mapDat[maptip] == 2){
                    stage_ex[maptip_num].backgroundColor = [UIColor colorWithRed:1.0f green:0.0f   blue:0.0f alpha:1.0f];
                    drawMap();
                }
                
            }
        }
//
        print_wall();   //上下壁表示

        //欄外塗りつぶし
        hanni.x1 = map_height + block_size - map_scroll_x;
        hanni.y1 = -block_size + ending_scroll_y - map_scroll_y;
        hanni.width = block_size*5;
        hanni.height = map_height + block_size;
        stage_ex[maptip_num].backgroundColor = [UIColor colorWithRed:0.0f green:0.0f   blue:1.0f alpha:1.0f];
        drawMap();

    }
}


/*============================================================================
●壁表示(引数なし)
//戻り値：なし
============================================================================*/
void print_wall(void){
    
    float block_size = BLOCK_SIZE;
    if(state == ENDING){
        block_size *= 0.4;
    }

    //外壁設定
    int length = block_size*(mapsize+2);

    //外壁（上）
    hanni.x1 = -map_scroll_x;
    hanni.y1 = -map_scroll_y + ending_scroll_y - block_size ;
    hanni.width = length;
    hanni.height = block_size ;
    stage_ex[maptip_num].backgroundColor = [UIColor colorWithRed:0.0f green:0.0f   blue:0.0f alpha:1.0f];
    drawMap();

    //外壁（左）
    hanni.x1 = -map_scroll_x;
    hanni.y1 = -map_scroll_y + ending_scroll_y - block_size ;
    hanni.width = block_size;
    hanni.height = length;
    stage_ex[maptip_num].backgroundColor = [UIColor colorWithRed:0.0f green:0.0f   blue:0.0f alpha:1.0f];
    drawMap();

    //外壁（下）
    hanni.x1 = -map_scroll_x;
    hanni.y1 = -map_scroll_y + ending_scroll_y + block_size*mapsize ;
    hanni.width = length;
    hanni.height = block_size;
    stage_ex[maptip_num].backgroundColor = [UIColor colorWithRed:0.0f green:0.0f   blue:0.0f alpha:1.0f];
    drawMap();

    //外壁（右）
    hanni.x1 = -map_scroll_x + block_size*(mapsize+1) ;
    hanni.y1 = -map_scroll_y + ending_scroll_y - block_size ;
    hanni.width = block_size;
    hanni.height = length;
    stage_ex[maptip_num].backgroundColor = [UIColor colorWithRed:0.0f green:0.0f   blue:0.0f alpha:1.0f];
    drawMap();



    return;
}

/*============================================================================
●マップの自動作成(XY二つメンバに上下左右の方向値を格納した構造体)
//戻り値：なし
============================================================================*/
void mapCreate(POS subpos){
    
	int mv;						//移動方向（乱数用）
	int movchk[4] = {0,0,0,0};	//4方向チェック
	POS mpos;
	int mx,my;					//周囲チェック用
	bool loopflag = true;		//ループフラグ
	int i;
	
	//穴掘り設定
    *(map + MapPos.y * mapsize + MapPos.x) = 1;	//穴
	
	//ゴール位置の設定
	SubCount++;					//深度カウンタアップ
	if(MaxCount < SubCount){
		MaxCount = SubCount;	//深度更新
		GoalPos = subpos;		//ゴール位置退避
	}
	
	
	while(loopflag){

		mv = rand() % 4;	//方向決定

		//移動済みチェック
		if(movchk[ mv ] == 0){
			
			movchk[ mv ] = 1;	//移動済みフラグON
			
			//奇数列移動チェック
			if( (mv == 1 || mv == 3)
			&&( subpos.x % 2) != 0 ){
				continue;
			}
			if( (mv == 0 || mv == 2)
			&&( subpos.y % 2) != 0 ){
				continue;
			}
			//仮移動
			mpos.x = subpos.x + r_move[ mv ].x;
			mpos.y = subpos.y + r_move[ mv ].y;
			
			//外壁チェック
			if(mpos.x < 0 || mpos.x > mapsize-1 || mpos.y < 0 || mpos.y > mapsize-1){
				continue;
			}
			//逆走チェック(既に掘り済み)
			if( *(map + mpos.y * mapsize + mpos.x) == 1){	//穴？
				continue;
			}
			for(i = 0; i < 4; i++){
				mx = mpos.x + r_move[ i ].x;
				my = mpos.y + r_move[ i ].y;
				
				if(mx < 0 || mx > mapsize-1 || my < 0 || my > mapsize-1 ){
					continue;	//外壁は問題なし
				}
				if(mx == subpos.x && my == subpos.y){
					continue;	//元位置は問題なし
				}
				if(*(map+my*mapsize+mx)==1){
					break;	//壁が薄い位置はNG
				}
			}
			if(i == 4){
				//移動座標決定
				MapPos = mpos;
				//再帰呼び出しでマップ作製
				mapCreate(MapPos);
			}
		}
		loopflag = false;
		for(i = 0; i < 4; i++){
			if(movchk[i] == 0){	//やってない方向があれば
				loopflag = true;
				break;
			}
		}
	}
	//深度カウンタの変更（浅く）
	SubCount--;
    return ;
}

/*============================================================================
●入力のリセット(引数なし)
//戻り値：なし
============================================================================*/
void reset_input(void){

    old_tap        = tap        ;
    old_left_move  = left_move  ;
    old_right_move = right_move ;
    old_up_move    = up_move    ;
    old_down_move  = down_move  ;

    tap = false;
    left_move = false;
    right_move = false;
    up_move = false;
    down_move = false;

}

/*============================================================================
●スクロールの実行(引数なし)
//戻り値：なし
============================================================================*/
void doScroll(void){

    //自機が画面の中央に来るようにする
    map_scroll_x = jiki_x - WINDOW_WIDTH / 2 + SELF_IMG_SIZE;
    map_scroll_y = jiki_y - WINDOW_HEIGHT / 2 + SELF_IMG_SIZE;

    //四隅の調整
    //上端
    if (map_scroll_y < 0)
    {
        map_scroll_y = 0;
    }
    //下端
    if (map_scroll_y > MAP_HEIGHT - WINDOW_HEIGHT)
    {
        map_scroll_y = MAP_HEIGHT - WINDOW_HEIGHT;
    }
    //左端
    if (map_scroll_x < 0)
    {
        map_scroll_x = 0;
    }
    //右端
    if (map_scroll_x > MAP_WIDTH - WINDOW_WIDTH)
    {
        map_scroll_x = MAP_WIDTH - WINDOW_WIDTH;
    }
}

/*============================================================================
●マップチップの描画(引数なし)
//戻り値：なし
============================================================================*/
void drawMap(void){

    stage_ex[maptip_num].frame = CGRectMake(hanni.x1, hanni.y1, hanni.width , hanni.height);
    [view.view addSubview:stage_ex[maptip_num]];
    maptip_num++;
    return;


}

/*============================================================================
●音再生(音楽番号、拡張子、ループ設定)
//戻り値：なし
============================================================================*/
void PlayMusic(int bgm_num, NSString *extension , bool loop){

    // 宣言
    NSError         *error;
    NSURL           *soundURL;

#if !XCODE_42
    SystemSoundID   soundID  ;
#endif

    // 初期化、代入
    error = Nil;
    soundURL = [[NSBundle mainBundle] URLForResource:bgm[bgm_num] withExtension:extension];
    g_bgm_num = bgm_num;    // 再生中音楽番号保持

    if([extension isEqual: EXTENSION_MP3]){
        player = [[AVAudioPlayer alloc] initWithContentsOfURL:soundURL error:&error];
        player.volume = 1;
        if(loop == true){
            player.numberOfLoops = -1;
        }
        else{
            player.numberOfLoops = 0;
        }
        // 再生
        [player prepareToPlay];
        [player play];
        [player prepareToPlay];
    }
    else{
#if !XCODE_42
        AudioServicesCreateSystemSoundID( (__bridge CFURLRef)soundURL , &soundID);
        AudioServicesPlaySystemSound( soundID );
#endif
        player_wav = [[AVAudioPlayer alloc] initWithContentsOfURL:soundURL error:&error];

        // 再生
        [player_wav prepareToPlay];
        [player_wav play];
    }

}
/*============================================================================
●音停止(音楽番号:C++移植用未使用)
//戻り値：なし
============================================================================*/
void StopMusic(int num){
    [player stop];
}
/*============================================================================
●AVAudioSessionの設定とハードウェアのサンプリングレートを設定(引数なし)
//戻り値：成功:true、失敗:false
============================================================================*/
-(BOOL)setupAudioSession{
#if 0 //!XCODE_42
    AVAudioSession *audioSession = [AVAudioSession sharedInstance];
    [audioSession setDelegate: view];
 
    NSError *audioSessionError = nil;
    [audioSession setCategory: AVAudioSessionCategoryPlayback error: &audioSessionError];
    if (audioSessionError != nil) {NSLog (@"Error setting audio session category."); return NO;}    
 
    _graphSampleRate = 44100.0;
     
    [audioSession setPreferredHardwareSampleRate: _graphSampleRate error: &audioSessionError];
    if (audioSessionError != nil) {NSLog (@"Error setting preferred hardware sample rate."); return NO;}
     
    [audioSession setActive: YES error: &audioSessionError];
    if (audioSessionError != nil) {NSLog (@"Error activating the audio session."); return NO;}
 
    _graphSampleRate = [audioSession currentHardwareSampleRate];
#endif
    return YES;
}

@end
