//==============================================
// ͏ [input.cpp]
//==============================================
#include "../head/input.h"

//******************************
// vg^Cv錾
//******************************/
// L[{[h֘A
HRESULT InitKeyboard(HINSTANCE hInst, HWND hWnd);
void UninitKeyboard(void);
HRESULT UpdateKeyboard(void);

// }EX֘A
HRESULT InitMouse(HINSTANCE hInst, HWND hWnd);
void UninitMouse(void);
HRESULT UpdateMouse(void);

// Q[pbh֘A
HRESULT InitJoypad(HINSTANCE hInst, HWND hWnd);
void UninitJoypad(void);
HRESULT UpdateJoypad(void);
BOOL CALLBACK EnumJoyCallback(const DIDEVICEINSTANCE* lpddi, VOID* pvRef);

//******************************
// O[oϐ
//******************************/
LPDIRECTINPUT8			g_pDInput = NULL;					// IDirectInput8C^[tF[Xւ̃|C^

LPDIRECTINPUTDEVICE8	g_pDIDevKeyboard = NULL;			// IDirectInputDevice8C^[tF[Xւ̃|C^(L[{[h)
LPDIRECTINPUTDEVICE8	g_pDIDevMouse = NULL;				// IDirectInputDevice8C^[tF[Xւ̃|C^(}EX)
LPDIRECTINPUTDEVICE8	g_pDIDevJoypad[MAX_CONTROLER];		// IDirectInputDevice8C^[tF[Xւ̃|C^(Q[pbh)


BYTE					g_keyState[256];					// L[{[hz
DIMOUSESTATE2			g_mouseState;						// }EXz
DIJOYSTATE				g_joyState[MAX_CONTROLER];			// Q[pbhz

BYTE					g_keyStatePrev[256];				// OL[{[hz
DIMOUSESTATE2			g_mouseStatePrev;					// O}EXz
DIJOYSTATE				g_joyStatePrev[MAX_CONTROLER];		// OQ[pbhz

int						g_nNumCont = 0;						// Q[pbh̐

//==============================
// ͏̏
//==============================
HRESULT InitInput(HINSTANCE hInst, HWND hWnd)
{
	HRESULT hr;

	if(!g_pDInput)
	{
		// DirectInputIuWFNg̍쐬
		hr = DirectInput8Create(hInst, DIRECTINPUT_VERSION,
									IID_IDirectInput8, (void**)&g_pDInput, NULL);
	}

	// L[{[h̏
	InitKeyboard(hInst, hWnd);

	// }EX̏
	InitMouse(hInst, hWnd);

	// Q[pbh̏
	InitJoypad(hInst, hWnd);

	return hr;
}

//==============================
// ͏̏I
//==============================
void UninitInput(void)
{
	// L[{[h̏I
	UninitKeyboard();

	// }EX̏I
	UninitMouse();

	// Q[pbh̏I
	UninitJoypad();

	if(g_pDInput)
	{
		g_pDInput->Release();
		g_pDInput = NULL;
	}
}

//==============================
// ͏̍XV
//==============================
void UpdateInput(void)
{
	// L[{[h̍XV
	UpdateKeyboard();

	// }EX̍XV
	UpdateMouse();

	// Q[pbh̍XV
	UpdateJoypad();
}

//==============================
// L[{[h̏
//==============================
HRESULT InitKeyboard(HINSTANCE hInst, HWND hWnd)
{
	HRESULT hr;

    // foCXIuWFNg쐬
	hr = g_pDInput->CreateDevice(GUID_SysKeyboard, &g_pDIDevKeyboard, NULL);
	if(FAILED(hr) || g_pDIDevKeyboard == NULL)
	{
		MessageBox(hWnd, _T("L[{[h˂I"), _T("xI"), MB_ICONWARNING);
		return hr;
	}

	// f[^tH[}bgݒ
	hr = g_pDIDevKeyboard->SetDataFormat(&c_dfDIKeyboard);
	if(FAILED(hr))
	{
		MessageBox(hWnd, _T("L[{[h̃f[^tH[}bgݒł܂łB"), _T("xI"), MB_ICONWARNING);
		return hr;
	}

	// [hݒitHAOEhr[hj
	hr = g_pDIDevKeyboard->SetCooperativeLevel(hWnd, (DISCL_FOREGROUND | DISCL_NONEXCLUSIVE));
	if(FAILED(hr))
	{
		MessageBox(hWnd, _T("L[{[h̋[hݒł܂łB"), _T("xI"), MB_ICONWARNING);
		return hr;
	}

	// L[{[hւ̃ANZXl(͐Jn)
	g_pDIDevKeyboard->Acquire();

#if !VS_COMPILE
    if(&hInst == 0x0000) {}    //Borland ϐgpWarning΍
#endif
    return S_OK;
}

//==============================
// L[{[h̏I
//==============================
void UninitKeyboard(void)
{
	if(g_pDIDevKeyboard)
	{
		g_pDIDevKeyboard->Unacquire();

		g_pDIDevKeyboard->Release();
		g_pDIDevKeyboard = NULL;
	}
}

//==============================
// L[{[h̍XV
//==============================
HRESULT UpdateKeyboard(void)
{
	HRESULT hr;

	// Ȏޔ
	for(int nLoop = 0; nLoop < 256; nLoop++)
		g_keyStatePrev[nLoop] = g_keyState[nLoop];

	// foCXf[^擾
	hr = g_pDIDevKeyboard->GetDeviceState(sizeof(g_keyState), g_keyState);

	if(FAILED(hr))
	{
		// L[{[hւ̃ANZX擾
		hr = g_pDIDevKeyboard->Acquire();
	}

	return hr;
}

//==============================
// }EX̏
//==============================
HRESULT InitMouse(HINSTANCE hInst, HWND hWnd)
{
	HRESULT hr;

	// foCXIuWFNg쐬
	hr = g_pDInput->CreateDevice(GUID_SysMouse, &g_pDIDevMouse, NULL);
	if(FAILED(hr) || g_pDIDevMouse == NULL)
	{
		MessageBox(hWnd, _T("}EX˂I"), _T("xI"), MB_ICONWARNING);
		return hr;
	}

	// f[^tH[}bgݒ
	hr = g_pDIDevMouse->SetDataFormat(&c_dfDIMouse2);
	if(FAILED(hr))
	{
		MessageBox(hWnd, _T("}EX̃f[^tH[}bgݒł܂łB"), _T( "xI"), MB_ICONWARNING);
		return hr;
	}

	// [hݒitHAOEhr[hj
	hr = g_pDIDevMouse->SetCooperativeLevel(hWnd, (DISCL_FOREGROUND | DISCL_NONEXCLUSIVE));
	if(FAILED(hr))
	{
		MessageBox(hWnd, _T("}EX̋[hݒł܂łB"), _T("xI"), MB_ICONWARNING);
		return hr;
	}

	// foCX̐ݒ
	{
		DIPROPDWORD dipdw;

		dipdw.diph.dwSize = sizeof(dipdw);
		dipdw.diph.dwHeaderSize = sizeof(dipdw.diph);
		dipdw.diph.dwObj = 0;
		dipdw.diph.dwHow = DIPH_DEVICE;
		dipdw.dwData = DIPROPAXISMODE_REL;

		//hr = g_pDIDevMouse->SetProperty(DIPROP_AXISMODE, &dipdw.diph);
	}

	// L[{[hւ̃ANZXl(͐Jn)
	g_pDIDevMouse->Acquire();

#if !VS_COMPILE
    if(&hInst == 0x0000) {}    //Borland ϐgpWarning΍
#endif

    return S_OK;
}

//==============================
// }EX̏I
//==============================
void UninitMouse(void)
{
	if(g_pDIDevMouse)
	{
		g_pDIDevMouse->Unacquire();

		g_pDIDevMouse->Release();
		g_pDIDevMouse = NULL;
	}
}

//==============================
// }EX̍XV
//==============================
HRESULT UpdateMouse(void)
{
	HRESULT hr;

	// Ȏޔ
	g_mouseStatePrev = g_mouseState;

	// foCXf[^擾
	hr = g_pDIDevMouse->GetDeviceState(sizeof(g_mouseState), &g_mouseState);

	if(FAILED(hr))
	{
		g_pDIDevMouse->Acquire();
	}

	return S_OK;
}

//==============================
// Q[pbh̏
//==============================
HRESULT InitJoypad(HINSTANCE hInst, HWND hWnd)
{
	HRESULT hr;

	// 
	for(int nLoop = 0; nLoop < MAX_CONTROLER; nLoop++)
	{
		g_pDIDevJoypad[nLoop] = NULL;
	}

	// foCXIuWFNg쐬(ڑĂWCpbh񋓂)
	hr = g_pDInput->EnumDevices(DI8DEVCLASS_GAMECTRL, EnumJoyCallback, NULL, DIEDFL_ATTACHEDONLY);
	if(FAILED(hr))
	{
		MessageBox(hWnd, _T("Q[pbhsI"), _T("xI"), MB_ICONWARNING);
		return hr;
	}

	// WCpbh̐
	for(int nLoop = 0; nLoop < MAX_CONTROLER; nLoop++)
	{
		// WCpbhȂꍇ͂΂
		if(g_pDIDevJoypad[nLoop] == NULL)
			continue;

		// f[^tH[}bg̐ݒ
		hr = g_pDIDevJoypad[nLoop]->SetDataFormat(&c_dfDIJoystick);
		if(FAILED(hr))
		{
			MessageBox(hWnd, _T("Q[pbh̃f[^tH[}bgݒł܂łB"), _T("xI"), MB_ICONWARNING);
			return hr;
		}

		// x̐ݒ
		hr = g_pDIDevJoypad[nLoop]->SetCooperativeLevel(hWnd, DISCL_NONEXCLUSIVE | DISCL_FOREGROUND);
		if(FAILED(hr))
		{
			MessageBox(hWnd, _T("Q[pbh̋[hݒł܂łB"), _T("xI"), MB_ICONWARNING);
			return hr;
		}

		// foCX̐ݒ
		{
			DIPROPRANGE diprg;
			ZeroMemory(&diprg, sizeof(diprg));		// \̂̒gׂă[NA
			diprg.diph.dwSize = sizeof(diprg);
			diprg.diph.dwHeaderSize = sizeof(diprg.diph);
			diprg.diph.dwObj = DIJOFS_X;
			diprg.diph.dwHow = DIPH_BYOFFSET;
			diprg.lMin       = -256;
			diprg.lMax       = 256;
			g_pDIDevJoypad[nLoop]->SetProperty(DIPROP_RANGE, &diprg.diph);	// w͈̔͂w
			diprg.diph.dwObj = DIJOFS_Y;
			diprg.diph.dwHow = DIPH_BYOFFSET;
			diprg.lMin       = -256;
			diprg.lMax       = 256;
			g_pDIDevJoypad[nLoop]->SetProperty(DIPROP_RANGE, &diprg.diph);	// x͈̔͂w
		}

		// foCXւ̓͐Jn
		g_pDIDevJoypad[nLoop]->Acquire();
		

	}

#if !VS_COMPILE
    if(&hInst == 0x0000) {}    //Borland ϐgpWarning΍
#endif

    return S_OK;
}

//==============================
// WCXeBbN₢킹pR[obN֐
//==============================
BOOL CALLBACK EnumJoyCallback(const DIDEVICEINSTANCE* lpddi, VOID* pvRef)
{
	DIDEVCAPS	diDevCaps;			// foCX
	HRESULT		hr;

	// WCXeBbNpfoCXIuWFNg쐬
	hr = g_pDInput->CreateDevice(lpddi->guidInstance, &g_pDIDevJoypad[g_nNumCont], NULL);
	if(FAILED(hr))
		return DIENUM_CONTINUE;		// 񋓂𑱂

	// WCXeBbN̔\͂𒲂ׂ
	diDevCaps.dwSize = sizeof(DIDEVCAPS);
	hr = g_pDIDevJoypad[g_nNumCont]->GetCapabilities(&diDevCaps);
	if(FAILED(hr))
	{
		if(g_pDIDevJoypad[g_nNumCont])
			g_pDIDevJoypad[g_nNumCont]->Release();
		g_pDIDevJoypad[g_nNumCont] = NULL;
		return DIENUM_CONTINUE;		// 񋓂𑱂
	}

#if !VS_COMPILE
    if(&pvRef == 0x0000) {}    //Borland ϐgpWarning΍
#endif
    
    // K萔ɒBI
	g_nNumCont++;
	if(g_nNumCont == MAX_CONTROLER)
		return DIENUM_STOP;		// 񋓂I
	else
		return DIENUM_CONTINUE;		// 񋓂𑱂

}

//==============================
// Q[pbh̏I
//==============================
void UninitJoypad(void)
{
	for(int nLoop = 0; nLoop < MAX_CONTROLER; nLoop++)
	{
		if(g_pDIDevJoypad[nLoop])
		{
			g_pDIDevJoypad[nLoop]->Unacquire();

			g_pDIDevJoypad[nLoop]->Release();
			g_pDIDevJoypad[nLoop] = NULL;
		}
	}
}

//==============================
// Q[pbh̍XV
//==============================
HRESULT UpdateJoypad(void)
{
	HRESULT hr;
	
	for(int nLoop = 0; nLoop < MAX_CONTROLER; nLoop++)
	{
		if(g_pDIDevJoypad[nLoop])
		{
			// Ȏޔ
			g_joyStatePrev[nLoop] = g_joyState[nLoop];

			// foCXf[^擾
			hr = g_pDIDevJoypad[nLoop]->GetDeviceState(sizeof(DIJOYSTATE), &g_joyState[nLoop]);

			if(FAILED(hr))
			{
				g_pDIDevJoypad[nLoop]->Acquire();
			}
		}
	}

	return S_OK;
}
