//-----------------------------------------------------------------------
// <copyright file="QuestionEntry.cs">
// </copyright>
//-----------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Text;
using System.Windows.Forms;
using DataManagement;
using UserControlLibrary;

namespace Gui
{
    /// <summary>
    /// ̓o^s
    /// </summary>
    public partial class QuestionEntry : Form
    {      
        #region tB[h

        /// <summary>
        /// ̓G[\bZ[W"Nx"
        /// </summary>
        private const string YEAR = "Nx";

        /// <summary>
        /// ̓G[\bZ[W"ԍ"
        /// </summary>
        private const string QUESTION_NO = "ԍ";

        /// <summary>
        /// ̓G[\bZ[W"蕶"
        /// </summary>
        private const string SENTENCE = "蕶";

        /// <summary>
        /// ̓G[\bZ[W"I"
        /// </summary>
        private const string CHOICE_SENTENCE = "I";

        /// <summary>
        /// a̔NxtH[}bgɒ߂̕
        /// </summary>
        private const string YEAR_TO_FORMAT = "{0}N11";

        /// <summary>
        /// a̕\`
        /// </summary>
        private const string YEAR_FORMAT_JA = "ggyyNMd";

        /// <summary>
        /// oJeSXg̕p
        /// </summary>
        private const int CATEGORY_SPACE = 15;

        /// <summary>
        /// f[^Xg
        /// </summary>
        private List<QuestionBase> lstQuestionBase;

        #endregion

        #region RXgN^

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="qsm">ǗNX̃CX^X</param>
        public QuestionEntry(QuestionManager qsm)
        {   
            // R|[lg
            this.InitializeComponent();

            // 擾
            this.lstQuestionBase = qsm.GetQuestionData();
        }

        #endregion

        #region Cxgnh
        /// <summary>
        /// o^{^NbN
        /// </summary>
        /// <param name="sender">Cxg̑M</param>
        /// <param name="e">Cxgf[^</param>
        private void btnAddQuestion_Click(object sender, EventArgs e)
        {
            try
            {
                // 胊Xg
                Question1Select4Answer q14 = new Question1Select4Answer();

                // ʂ̏Xgɑ

                // Nx
                if (string.IsNullOrEmpty(this.cmbEntryYear.Text.Trim()))
                {
                    this.ShowError(YEAR);
                    return;
                }
                else
                {
                    DateTime a_d = this.ChangeAD(this.cmbEntryYear.Text.Trim());
                    q14.Year = a_d.Year;
                }

                // 
                q14.Season = this.cmbEntrySeason.Text.Trim();

                // ԋ敪
                q14.TimeDiv = this.cmbEntryAMPM.Text.Trim();

                // ԍ
                if (string.IsNullOrEmpty(this.cmbEntryQuestionNo.Text.Trim()))
                {
                    this.ShowError(QUESTION_NO);
                    return;
                }
                else
                {
                    q14.QuestionNo = int.Parse(this.cmbEntryQuestionNo.Text.Trim());
                }

                // `
                q14.QuestionForm = this.cmbEntryQuestionForm.SelectedIndex;

                // JeS
                q14.Category = this.cmbEntryCategory.Text.Trim();

                // 𓚋L
                q14.Answer = this.cmbEntryAnswer.SelectedIndex;

                // 蕶
                q14.Sentence = this.txbEntrySentence.Text.Trim();

                // I
                q14.Choices[0] = this.txbEntryChoices_A.Text.Trim();
                q14.Choices[1] = this.txbEntryChoices_I.Text.Trim();
                q14.Choices[2] = this.txbEntryChoices_U.Text.Trim();
                q14.Choices[3] = this.txbEntryChoices_E.Text.Trim();

                // ̓`FbN
                if (string.IsNullOrEmpty(q14.Sentence))
                {
                    this.ShowError(SENTENCE);
                    return;
                }
                else
                {
                    foreach (string choice in q14.Choices)
                    {
                        if (string.IsNullOrEmpty(choice))
                        {
                            this.ShowError(CHOICE_SENTENCE);
                            return;
                        }
                    }
                }

                // o^d`FbN
                foreach (QuestionBase lstqb in this.lstQuestionBase)
                {
                    if ((q14.Year == lstqb.Year)
                    && (q14.Season == lstqb.Season)
                    && (q14.TimeDiv == lstqb.TimeDiv)
                    && (q14.QuestionNo == lstqb.QuestionNo))
                    {
                        MessageBox.Show(Gui.Properties.Message2.E_002, Gui.Properties.MessageTitle2.T_005);
                        return;
                    }
                }

                this.lstQuestionBase.Add(q14);

                // o^bZ[W\
                MessageBox.Show(Gui.Properties.Message2.N_001, Gui.Properties.MessageTitle2.T_001);

                this.InitializeQuestion();
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.ToString());
            }
        }

        /// <summary>
        /// Cj[փ{^NbN
        /// </summary>
        /// <param name="sender">Cxg̑M</param>
        /// <param name="e">Cxgf[^</param>
        private void btnEntryToMainMenu_Click(object sender, EventArgs e)
        {
            try
            {
                DialogResult dlr;

                // mFbZ[W\
                dlr = MessageBox.Show(Gui.Properties.Message2.C_003, Gui.Properties.MessageTitle2.T_002, MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (dlr == DialogResult.Yes)
                {
                    this.Close();
                }
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.ToString());
            }
        }

        #endregion

        #region private\bh

        /// <summary>
        /// e񏉊
        /// </summary>
        private void InitializeQuestion()
        {
            // Nx
            this.cmbEntryYear.SelectedItem = 22;

            // 
            this.cmbEntrySeason.SelectedIndex = 0;

            // ԋ敪iߑOŒj
            this.cmbEntryAMPM.SelectedIndex = 0;

            // ԍ
            this.cmbEntryQuestionNo.SelectedIndex = 0;

            // `ilґŒj
            this.cmbEntryQuestionForm.SelectedIndex = 0;

            // JeS
            this.cmbEntryCategory.SelectedIndex = 0;

            // 𓚋L
            this.cmbEntryAnswer.SelectedIndex = 0;

            // 蕶
            this.txbEntrySentence.Text = string.Empty;

            // I
            this.txbEntryChoices_A.Text = string.Empty;
            this.txbEntryChoices_I.Text = string.Empty;
            this.txbEntryChoices_U.Text = string.Empty;
            this.txbEntryChoices_E.Text = string.Empty;
        }

        /// <summary>
        /// R{{bNX͔͈́Ảʕ\񏉊
        /// </summary>
        /// <param name="sender">Cxg̑M</param>
        /// <param name="e">Cxgf[^</param>
        private void QuestionEntry_Load(object sender, EventArgs e)
        {
            try
            {
                // o^Nx͔͈̓͂
                this.cmbEntryYear.InputScope = new InputScope(1, 99);
                this.cmbEntryYear.DisabledKeys.Add((int)Keys.Delete);
                this.cmbEntryYear.DisabledKeys.Add((int)Keys.Space);

                // o^ԍ͔͈̓͂
                this.cmbEntryQuestionNo.InputScope = new InputScope(1, 80);
                this.cmbEntryQuestionNo.DisabledKeys.Add((int)Keys.Delete);
                this.cmbEntryQuestionNo.DisabledKeys.Add((int)Keys.Space);

                // 񏉊
                this.InitializeQuestion();

                // oJeS̃Xg̓I␳
                this.DynamicCmbLstWidth();
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.ToString());
            }
        }

        /// <summary>
        /// a𐼗ɕϊ܂B
        /// </summary>
        /// <param name="japan_year_value">ʏŐݒ肵݂̔Nx</param>
        /// <returns>ϊf[^</returns>
        private DateTime ChangeAD(string japan_year_value)
        {
            CultureInfo cinfo = new CultureInfo("ja-JP", true);
            JapaneseCalendar jc = new JapaneseCalendar();
            cinfo.DateTimeFormat.Calendar = jc;
            string japan_year = string.Format(YEAR_TO_FORMAT, japan_year_value);
            DateTime a_d = DateTime.ParseExact(japan_year, YEAR_FORMAT_JA, cinfo);
            return a_d;
        }

        /// <summary>
        /// oJeS̃Xg̓I␳
        /// </summary>
        private void DynamicCmbLstWidth()
        {
            Graphics g = this.cmbEntryCategory.CreateGraphics();
            int widthmax = 0;
            foreach (string text in this.cmbEntryCategory.Items)
            {
                widthmax = (int)Math.Max(widthmax, g.MeasureString(text, this.cmbEntryCategory.Font).Width);
            }

            this.cmbEntryCategory.DropDownWidth = widthmax + CATEGORY_SPACE;
        }

        /// <summary>
        /// ̓G[\
        /// </summary>
        /// <param name="blankitem">͍ږ</param>
        private void ShowError(string blankitem)
        {
            MessageBox.Show(string.Format(Gui.Properties.Message2.E_001, blankitem), Gui.Properties.MessageTitle2.T_004);
        }
        #endregion
    }
}
