//-----------------------------------------------------------------------
// <copyright file="QuestionEntryBase.cs">
// </copyright>
//-----------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.IO;
using System.Text;
using System.Windows.Forms;
using DataManagement;
using UserControlLibrary;

namespace Gui.EntryManager
{
    /// <summary>
    /// o^܂B
    /// </summary>
    public partial class QuestionEntryBase : Form
    {
        #region vCx[g 萔tB[h
        /// <summary>
        /// ̓G[\bZ[W"Nx"
        /// </summary>
        private const string YEAR = "Nx";

        /// <summary>
        /// o^p̕łB
        /// </summary>
        private const string SAVE_CREATE = "o^";

        /// <summary>
        /// ҏWp̕łB
        /// </summary>
        private const string EDIT = "ҏW";

        /// <summary>
        /// 폜p̕łB
        /// </summary>
        private const string DELETE = "폜";

        /// <summary>
        /// oJeSXg̕p
        /// </summary>
        private const int CATEGORY_SPACE = 15;

        /// <summary>
        /// {^̑Έړʒu(ʉ炢̈ʒu)
        /// </summary>
        private const int BOTOM_BLANK_MENU = 65;

        /// <summary>
        /// ̓{^̑Έړʒu(ʉ炢̈ʒu)
        /// </summary>
        private const int BOTOM_BLANK_INPUT = 94;

        #endregion

        #region vCx[g tB[h
        /// <summary>
        /// o^̃C^[tF[X
        /// </summary>
        private IEntry[] entry;

        /// <summary>
        /// }i[TextBox
        /// </summary>
        private TextBox txbInsertionTarget;

        /// <summary>
        /// AҏWʂɂȂ痧tOłB
        /// </summary>
        private bool editing;

        /// <summary>
        /// ԋ敪؂ւ钼O̒lێ܂B
        /// </summary>
        private int beforeTimeDiv;

        /// <summary>
        /// ԋ敪ɂĕςtH[̍̊lłB
        /// </summary>
        private int baseHeight;

        /// <summary>
        /// 摜}݈̌ʒuCpϐłB
        /// </summary>
        private string currentDirectoryPos;

        #endregion

        #region pubN RXgN^
        /// <summary>
        /// o^ʂ̋ʍڂłB
        /// </summary>
        public QuestionEntryBase()
        {
            // 
            this.InitializeComponent();
            this.Initialize();
        }
        #endregion

        /// <summary>
        /// ԋ敪̗vfʒũXgłB
        /// </summary>
        private enum TIMEDIV
        {
            /// <summary>
            /// ߑO̖i[ĂC^tF[XʒułB
            /// </summary>
            BEFORE_NOON = 0,

            /// <summary>
            /// ߌ̖i[ĂC^tF[XʒułB
            /// </summary>
            AFTER_NOON,

            /// <summary>
            /// C^[tF[X̗vfłB
            /// </summary>
            END_NUM
        }

        #region vCx[g \bh
        /// <summary>
        /// o[Aʒu߂܂B
        /// </summary>
        private void Initialize()
        {
            // }eLXg{bNXɑ
            this.txbInsertionTarget = null;

            // 摜}_CAÕt@CJCxgɃCxgǉ
            this.ofdImageInsertion.FileOk += new CancelEventHandler(this.ofdImageInsertion_FileOk);

            // CAEg
            this.entry = new IEntry[this.cmbEntryAMPM.Items.Count];
            this.entry[(int)TIMEDIV.BEFORE_NOON] = new EntryForenoon();
            this.entry[(int)TIMEDIV.AFTER_NOON] = new EntryAfternoon();

            // tH[̍ߗp
            this.baseHeight = this.Height - ((UserControl)this.entry[0]).Height;

            // CfbNXl̐ݒ
            this.editing = false;
            this.cmbEntryYear.SelectedIndex = 0;
            this.cmbEntrySeason.SelectedIndex = 0;
            this.cmbEntryAMPM.SelectedIndex = 0;
            this.cmbEntryQuestionForm.SelectedIndex = 0;

            // XgtH[JXRg[CxgɃnhǉ
            foreach (IEntry entry_timeDiv in this.entry)
            {
                entry_timeDiv.LostFocusControl += new FocusEventHandler(this.item_LostFocusControl);
            }

            // 莑ǉʃ{^Ƃ̋ǉ(ߌp)
            ((EntryAfternoon)this.entry[(int)TIMEDIV.AFTER_NOON]).ClickReferenceAddition += new EventHandler(this.item_btnInformationAddtion_Click);

            // 폜{^̉B؂
            this.btnDeleteQuestion.Visible = false;
        }

        /// <summary>
        /// ʉɂ{^AtH[̍̑ΈʒuɂĈړ܂B
        /// </summary>
        private void MoveButton()
        {
            this.btnImageInsertion.Top = this.Height - BOTOM_BLANK_INPUT;
            this.btnCommonRuleAddtion.Top = this.Height - BOTOM_BLANK_INPUT;
            this.btnEntryToMainMenu.Top = this.Height - BOTOM_BLANK_MENU;
            this.btnSearchQuestion.Top = this.Height - BOTOM_BLANK_MENU;
            this.btnEntryPrev.Top = this.Height - BOTOM_BLANK_MENU;
            this.btnAddQuestion.Top = this.Height - BOTOM_BLANK_MENU;
            this.btnDeleteQuestion.Top = this.Height - BOTOM_BLANK_MENU;
        }

        /// <summary>
        /// ̓G[\
        /// </summary>
        /// <param name="blankitem">͍ږ</param>
        private void ShowError(string blankitem)
        {
            MessageBox.Show(string.Format(Gui.Properties.Message.E_001, blankitem), Gui.Properties.MessageTitle.T_004);
        }

        /// <summary>
        /// ԋ敪̒lI܂B
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void TimeDiv_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Rg[̈ʒuړĂȂړ
            if (this.entry[this.cmbEntryAMPM.SelectedIndex].PosY != this.cmbEntryQuestionForm.Location.Y + this.cmbEntryQuestionForm.Size.Height)
            {
                this.entry[this.cmbEntryAMPM.SelectedIndex].PosY = this.cmbEntryQuestionForm.Location.Y + this.cmbEntryQuestionForm.Size.Height;
            }

            // tH[̍
            this.Height = this.baseHeight + ((UserControl)this.entry[this.cmbEntryAMPM.SelectedIndex]).Height;

            // C^[tF[XɓĂľ^[U[Rg[̏ꍇ
            if (this.entry[this.beforeTimeDiv] is UserControl)
            {
                // ÕRg[͂
                this.Controls.Remove((UserControl)this.entry[this.beforeTimeDiv]);
            }

            // C^[tF[XɓĂľ^[U[Rg[̏ꍇ
            if (this.entry[this.cmbEntryAMPM.SelectedIndex] is UserControl)
            {
                // ړĨRg[t
                this.Controls.Add((UserControl)this.entry[this.cmbEntryAMPM.SelectedIndex]);
            }

            // {^̈ړ
            this.MoveButton();

            // ȑO̎ԋ敪̑Ilێ
            this.beforeTimeDiv = this.cmbEntryAMPM.SelectedIndex;
        }

        /// <summary>
        /// Cj[փ{^NbN
        /// </summary>
        /// <param name="sender">Cxg̑M</param>
        /// <param name="e">Cxgf[^</param>
        private void btnEntryToMainMenu_Click(object sender, EventArgs e)
        {
            try
            {
                DialogResult dlr;

                // mFbZ[W\
                dlr = MessageBox.Show(Gui.Properties.Message.C_003, Gui.Properties.MessageTitle.T_002, MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (dlr == DialogResult.Yes)
                {
                    this.Close();
                }
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.ToString());
            }
        }

        /// <summary>
        /// o^XgJ܂B
        /// </summary>
        /// <param name="sender">Cxg̑M</param>
        /// <param name="e">Cxgf[^</param>
        private void btnSearchQuestion_Click(object sender, EventArgs e)
        {
            // ʂJ
            QuestionEntryList classQuestionList = new QuestionEntryList();
            classQuestionList.ShowDialog();

            // ʂœIDgpĊY擾
            QuestionManager qm = QuestionManager.GetInstance();
            QuestionBase qb = null;
            try
            {
                qb = qm.GetQuestionById<QuestionBase>(classQuestionList.Id);
            }
            catch
            {   // 擾Ɍʂꍇ
                qb = null;
            }

            // 擾ꍇAeRg[ɊYڂ̒lݒ肷
            if (qb != null)
            {
                // aϊ
                string year_str = CommonLibrary.ChangeJP(qb.Year).Substring(2);
                int year_num = int.Parse(year_str);

                // ʂ̃Rg[ɊY̊eڂ̒lݒ
                this.cmbEntryYear.SelectedIndex = this.cmbEntryYear.Items.Count - year_num;
                this.cmbEntrySeason.SelectedIndex = qb.Season;
                this.cmbEntryAMPM.SelectedIndex = qb.TimeDivision;
                this.entry[this.cmbEntryAMPM.SelectedIndex].SetQuestion = qb;

                // ߑȌꍇƌߌ̏ꍇ̖`ݒ肷
                if (this.cmbEntryAMPM.SelectedIndex == QuestionScope.FORENOON)
                {
                    this.cmbEntryQuestionForm.SelectedIndex = 0;
                }
                else if (this.cmbEntryAMPM.SelectedIndex == QuestionScope.AFTERNOON)
                {
                    this.cmbEntryQuestionForm.SelectedIndex = 1;
                }
                else
                {
                    // Ȃ
                }

                // 폜{^̕\
                this.btnDeleteQuestion.Visible = true;

                // ҏW[hɈڍs
                this.btnAddQuestion.Text = "ҏW";
                this.cmbEntryYear.Enabled = false;
                this.cmbEntrySeason.Enabled = false;
                this.cmbEntryAMPM.Enabled = false;
                this.editing = true;
            } // ʎ擾
        }

        /// <summary>
        /// 摜}{^NbN
        /// </summary>
        /// <param name="sender">Cxg̑M</param>
        /// <param name="e">Cxgf[^</param>
        private void btnImageInsertion_Click(object sender, EventArgs e)
        {
            if (this.txbInsertionTarget != null)
            {
                // 摜}_CAO\
                this.currentDirectoryPos = Directory.GetCurrentDirectory();
                this.ofdImageInsertion.ShowDialog();
            }
            else
            {
                MessageBox.Show("ǂ̃eLXg{bNXɉ摜}邩AIĉB");
            }
        }

        /// <summary>
        /// 摜}_CAOŊJ{^NbNꂽ
        /// </summary>
        /// <param name="sender">Cxg̑M</param>
        /// <param name="e">Cxgf[^</param>
        private void ofdImageInsertion_FileOk(object sender, CancelEventArgs e)
        {
            // }eLXgɉ摜^O}
            this.txbInsertionTarget.SelectedText = string.Format(Properties.Settings.Default.IMAGE_TAG_FORMAT, ((OpenFileDialog)sender).FileName);
            Directory.SetCurrentDirectory(this.currentDirectoryPos);
        }

        /// <summary>
        /// o^(ҏW){^ƂAo^(ҏW)܂B
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void btnAddQuestion_Click(object sender, EventArgs e)
        {
            QuestionManager qm;
            QuestionBase qb;
            DateTime a_d;

            qm = QuestionManager.GetInstance();
            qb = this.entry[this.cmbEntryAMPM.SelectedIndex].CreateQuestion();
            a_d = new DateTime();
            
            if (this.Check_And_Substitution_Preparation(qb, a_d) == true)
            {   // `FbN
                return;
            }

            try
            {   // o^d`FbN
                qb = qm.GetQuestionById<QuestionBase>(QuestionBase.ConvertToId(qb.Year, qb.Season, qb.TimeDivision, qb.QuestionNumber));
                
                if ((qb != null) 
                && (this.editing != true))
                {   // VKo^ŏdĂꍇAӕ\
                    MessageBox.Show(Gui.Properties.Message.E_002, Gui.Properties.MessageTitle.T_005);
                    qb = null;
                }
            }
            catch
            {   // 肪݂Ȃꍇ͉Ȃ
            }
            finally
            {   // ҏWo^܂B
                this.Do_EditorRegistration(qm, qb);
            }   // finary
        }   // o^{^

        /// <summary>
        /// mFƑ܂B
        /// </summary>
        /// <param name="qb">i[܂B</param>
        /// <param name="a_d">ϊNłB</param>
        /// <returns>łtrueԂ܂B</returns>
        private bool Check_And_Substitution_Preparation(QuestionBase qb, DateTime a_d)
        {
            try
            {
                // f[^̗L`FbN
                qb.CheckEmpty();
            }
            catch (EmptyException ex)
            {
                this.ShowError(ex.Message);
                return true;
            }

            // Nx
            if (string.IsNullOrEmpty(this.cmbEntryYear.Text.Trim()))
            {
                this.ShowError(YEAR);
                return true;
            }
            else
            {
                a_d = CommonLibrary.ChangeAD(this.cmbEntryYear.Text.Trim());
                qb.Year = a_d.Year;
            }

            // 
            qb.Season = this.cmbEntrySeason.SelectedIndex;

            // ԋ敪
            qb.TimeDivision = this.cmbEntryAMPM.SelectedIndex;

            return false;
        }

        /// <summary>
        /// ҏWo^s܂B
        /// </summary>
        /// <param name="qm">Ǘgp܂B</param>
        /// <param name="qb">ҏWo^Y̖łB</param>
        private void Do_EditorRegistration(QuestionManager qm, QuestionBase qb)
        {
            // G[ȂΓo^
            if (qb != null)
            {
                // ҏWłȂΊYǉ
                if (this.editing != true)
                {
                    // 錾
                    DialogResult dlr;

                    // _CAOʂ
                    dlr = MessageBox.Show(Properties.Message.C_004, Properties.MessageTitle.T_002, MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                    if (dlr == DialogResult.Yes)
                    {
                        qm.Add(qb);

                        this.CancelEdit(SAVE_CREATE);
                    }
                }
                else
                {
                    if (MessageBox.Show("͓eŖҏW܂B낵łH", Gui.Properties.MessageTitle.T_001, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                    {
                        // ҏW
                        qb.Year = CommonLibrary.ChangeAD(this.cmbEntryYear.Text).Year;
                        qb.Season = this.cmbEntrySeason.SelectedIndex;
                        qb.TimeDivision = this.cmbEntryAMPM.SelectedIndex;

                        this.entry[this.cmbEntryAMPM.SelectedIndex].GetControlValue(qb);

                        this.CancelEdit(EDIT);
                    }
                }
            }   // o^orҏW
        }

        /// <summary>
        /// ҏW[hAVKo^ʃ[hɖ߂܂B
        /// </summary>
        /// <param name="mode">̂̕i[܂B</param>
        private void CancelEdit(string mode)
        {
            // bZ[W\
            MessageBox.Show(string.Format(Gui.Properties.Message.N_001, mode), string.Format(Gui.Properties.MessageTitle.T_001, mode));

            // ҏW[h
            this.cmbEntryYear.Enabled = true;
            this.cmbEntrySeason.Enabled = true;
            this.cmbEntryAMPM.Enabled = true;

            // 폜{^폜
            this.btnDeleteQuestion.Visible = false;

            // ҏW[h
            this.editing = false;

            // ҏW{^o^{^֕ύX
            this.btnAddQuestion.Text = "o^";

            // ͓ẽNA
            this.entry[this.cmbEntryAMPM.SelectedIndex].ClearItems();
        }

        /// <summary>
        /// ̃Rg[̃tH[JXꂽ
        /// </summary>
        /// <param name="sender">Cxg̑M</param>
        /// <param name="e">Cxgf[^</param>
        private void item_LostFocusControl(object sender, FocusEventArgs e)
        {
            if (e.Source is TextBox)
            {
                this.txbInsertionTarget = (TextBox)e.Source;
            }
        }
        #endregion

        /// <summary>
        /// 苤ʎdl{^Ƃ̋łB
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void btnCommonRuleAddtion_Click(object sender, EventArgs e)
        {
            AddInformation addInformation = new AddInformation(this.cmbEntryYear.Text, this.cmbEntrySeason.SelectedIndex, this.cmbEntryAMPM.SelectedIndex, 0);
            addInformation.ShowDialog();
        }

        /// <summary>
        /// 莑ǉ{^Ƃ̋łB
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void item_btnInformationAddtion_Click(object sender, EventArgs e)
        {
            AddInformation addInformation = new AddInformation(this.cmbEntryYear.Text, this.cmbEntrySeason.SelectedIndex, this.cmbEntryAMPM.SelectedIndex, 1);
            addInformation.ShowDialog();
        }

        /// <summary>
        /// 폜܂B
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void btnDeleteQuestion_Click(object sender, EventArgs e)
        {
            // 폜܂B
            QuestionManager qm = QuestionManager.GetInstance();

            if (MessageBox.Show("폜܂B낵łH", Gui.Properties.MessageTitle.T_002, MessageBoxButtons.YesNo, MessageBoxIcon.Question)
                == DialogResult.Yes)
            {
                // 폜̗p
                int year;
                int season;
                int timeDiv;
                int qnum;
                int id;
                QuestionBase qb;

                // ID̐ݒ
                year = CommonLibrary.ChangeAD(this.cmbEntryYear.Text.Trim()).Year;
                season = this.cmbEntrySeason.SelectedIndex;
                timeDiv = this.cmbEntryAMPM.SelectedIndex;
                qnum = this.entry[this.cmbEntryAMPM.SelectedIndex].GetQuestionNumber();

                try
                {   // IDƖ̎擾
                    id = QuestionBase.ConvertToId(year, season, timeDiv, qnum);
                    qb = qm.GetQuestionById<QuestionBase>(id);

                    // ̍폜
                    qm.Remove(qb);
                    this.CancelEdit(DELETE);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                } // ̍폜
            } // 폜I񂾂Ƃ
        } // 폜Rg[
    } // class
} // namespace
