//-----------------------------------------------------------------------
// <copyright file="QuestionSolveBase.cs">
// </copyright>
//-----------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Text;
using System.Windows.Forms;
using DataManagement;
using UserControlLibrary;

namespace Gui
{
    /// <summary>
    /// ̉񓚂sʂłB
    /// </summary>
    public partial class QuestionSolveBase : Form
    {
        #region private field
        /// <summary>
        /// Jnԍ`܂B
        /// </summary>
        private const int QUESTION_NUMBER_START = 1;

        /// <summary>
        /// vI`܂B
        /// </summary>
        private const int CHOICE_NUMBER_SUM = 4;

        /// <summary>
        /// ̌`܂B
        /// </summary>
        private const int HEISEI = 4;

        /// <summary>
        /// ǗIuWFNgi[܂B
        /// </summary>
        private QuestionManager qsm;

        /// <summary>
        /// 胊Xgi[܂B
        /// </summary>
        private List<QuestionBase> lstQuestionBase;

        /// <summary>
        /// IXgi[܂B
        /// </summary>
        private List<Choice> lstChoice;
        #endregion

        #region public constructor
        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="qsmArg">ǗIuWFNgi[܂B</param>
        public QuestionSolveBase(QuestionManager qsmArg)
        {
            // R|[lg
            this.InitializeComponent();

            // ǗIuWFNg
            this.qsm = qsmArg;

            // Ȉ
            this.InitializeChoice();

            // Jn
            this.StartQuestion();
        }
        #endregion

        #region protected property
        /// <summary>
        /// [h擾yѐݒ肵܂B
        /// </summary>
        protected string Mode
        {
            get { return this.lblMode.Text; }
            set { this.lblMode.Text = value; }
        }
        #endregion

        #region private property
        /// <summary>
        /// ݖ萔擾yѐݒ肵܂B
        /// </summary>
        private int QuestionNumberNow
        {
            get { return int.Parse(this.lblQuestionNumberNow.Text); }
            set { this.lblQuestionNumberNow.Text = value.ToString(); }
        }

        /// <summary>
        /// c莞Ԃ擾yѐݒ肵܂B
        /// </summary>
        private int RestTime
        {
            get { return int.Parse(this.lblRestTimeValue.Text); }
            set { this.lblRestTimeValue.Text = value.ToString(); }
        }

        /// <summary>
        /// 𓚕\tO擾yѐݒ肵܂B
        /// </summary>
        private bool ShowedAnswer
        {
            set
            {
                if (value)
                {
                    // ^C}[~
                    this.tmr.Stop();
                }

                // SI̓\
                foreach (Choice cho in this.lstChoice)
                {
                    if (value)
                    {
                        // Cxg폜
                        cho.Click -= new EventHandler(this.Choice_Click);
                    }
                    else
                    {
                        // Cxgǉ
                        cho.Click += new EventHandler(this.Choice_Click);
                    }

                    // 𓚕\tOɑ
                    cho.ShowedAnswer = value;
                }

                // Jڃ{^̃eLXgݒ
                this.btnTransit.Text = value ? "" : "";

                if (value)
                {
                    // CxgnhύX
                    this.btnTransit.Click -= new EventHandler(this.btnTransitReply_Click);
                    this.btnTransit.Click += new EventHandler(this.btnTransitToNext_Click);
                }
                else
                {
                    // CxgnhύX
                    this.btnTransit.Click -= new EventHandler(this.btnTransitToNext_Click);
                    this.btnTransit.Click += new EventHandler(this.btnTransitReply_Click);
                }
            }
        }
        #endregion

        #region private static method
        /// <summary>
        /// w肳ꂽ̔Nxɕϊ܂B
        /// </summary>
        /// <param name="era">i[܂B</param>
        /// <param name="year">i[܂B</param>
        /// <returns>w肳ꂽ̔NxԂ܂B</returns>
        private static int ConvertToJapaneseYear(int era, int year)
        {
            // 錾
            JapaneseCalendar jpc;   // {̃J_[
            DateTime dttFirstDay;   // Jn
            DateTime dttLastDay;    // I

            // {̃J_[̏
            jpc = new JapaneseCalendar();

            // Jn̏
            dttFirstDay = new DateTime(year, 1, 1);

            // Ȉ
            dttLastDay = new DateTime(year, 12, 31);

            if (jpc.GetEra(dttFirstDay) == era)
            {   // Jňw肳ꂽȂ

                // NxԂ
                return jpc.GetYear(dttFirstDay);
            }
            else if (jpc.GetEra(dttLastDay) == era)
            {   // Ǐw肳ꂽȂ

                // NxԂ
                return jpc.GetYear(dttLastDay);
            }
            else
            {
                // O𓊂
                throw new Exception("w肳ꂽ̔Nxɕϊo܂B");
            }
        }
        #endregion

        #region private method
        /// <summary>
        /// ^C}[쓮
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void tmr_Tick(object sender, EventArgs e)
        {
            try
            {
                // c莞ԂfNg
                this.RestTime--;

                if (this.RestTime <= 0)
                {
                    // ^C}[~
                    this.tmr.Stop();

                    // 𓚕\tOɑ
                    this.ShowedAnswer = true;
                }
            }
            catch (Exception exc)
            {
                // bZ[W{bNX\
                MessageBox.Show(exc.ToString());
            }
        }

        /// <summary>
        /// INbNꂽ
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void Choice_Click(object sender, EventArgs e)
        {
            try
            {
                // SI𖢃`FbNԂ
                foreach (Choice cho in this.lstChoice)
                {
                    // `FbNԂ
                    cho.Checked = false;
                }

                // NbNꂽI`FbNԂ
                ((Choice)sender).Checked = true;
            }
            catch (Exception exc)
            {
                // bZ[W{bNX\
                MessageBox.Show(exc.ToString());
            }
        }

        /// <summary>
        /// [hIփ{^NbNꂽ
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void btnToModeSelect_Click(object sender, EventArgs e)
        {
            try
            {
                // 錾
                DialogResult dlr;   // _CAO

                // bZ[W{bNX\
                dlr = MessageBox.Show(Gui.Properties.Message2.C_001, Gui.Properties.MessageTitle2.T_002, MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                if (dlr == DialogResult.Yes)
                {
                    // ̉ʂ
                    this.Close();
                }
            }
            catch (Exception exc)
            {
                // bZ[W{bNX\
                MessageBox.Show(exc.ToString());
            }
        }

        /// <summary>
        /// 񓚃{^NbNꂽ
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void btnTransitReply_Click(object sender, EventArgs e)
        {
            try
            {
                // 񓚕\tOݒ
                this.ShowedAnswer = true;
            }
            catch (Exception exc)
            {
                // bZ[W{bNX\
                MessageBox.Show(exc.ToString());
            }
        }

        /// <summary>
        /// փ{^NbNꂽ
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void btnTransitToNext_Click(object sender, EventArgs e)
        {
            try
            {
                // Sĉ񓚂Ȃ
                if (this.QuestionNumberNow >= this.lstQuestionBase.Count)
                {
                    // I
                    this.EndQuestion();
                }
                else
                {
                    // 𓚕\tOݒ
                    this.ShowedAnswer = false;

                    // ݖԍCNg
                    this.QuestionNumberNow++;

                    // ݒ
                    this.SetQuestion();
                }
            }
            catch (Exception exc)
            {
                // bZ[W{bNX\
                MessageBox.Show(exc.ToString());
            }
        }

        /// <summary>
        /// I܂B
        /// </summary>
        private void InitializeChoice()
        {
            // 錾
            int i;                      // [vϐi
            string[] strKataId;         // J^JiIDz
            Choice cho;                 // I

            // IXg
            this.lstChoice = new List<Choice>(CHOICE_NUMBER_SUM);

            // J^JiIDz
            strKataId = new string[] { "A", "C", "E", "G" };

            for (i = 0; i < CHOICE_NUMBER_SUM; i++)
            {
                // I
                cho = new Choice(strKataId[i]);

                // WύX
                cho.Location = new Point((200 * i) + 10, 330);

                // Cxgǉ
                cho.Click += new EventHandler(this.Choice_Click);

                // IXgɒǉ
                this.lstChoice.Add(cho);
                
                // Rg[ɒǉ
                this.Controls.Add(cho);
            }
        }

        /// <summary>
        /// Jn܂B
        /// </summary>
        private void StartQuestion()
        {
            // 胊Xgɑ
            this.lstQuestionBase = this.qsm.GetQuestionData(Gui.Properties.Settings.Default.QuestionNumberSum);

            // ő萔xݒ
            this.lblQuestionNumberSum.Text = this.lstQuestionBase.Count.ToString();

            // ݖԍ
            this.QuestionNumberNow = QUESTION_NUMBER_START;

            // ݒ
            this.SetQuestion();
        }

        /// <summary>
        /// ݒ肵܂B
        /// </summary>
        private void SetQuestion()
        {
            // 錾
            Question1Select4Answer q14; // lґ

            // lґ
            q14 = (Question1Select4Answer)this.lstQuestionBase[this.QuestionNumberNow - 1];

            // c莞Ԃݒ
            this.RestTime = Gui.Properties.Settings.Default.LimitTime;

            // NxxXV
            this.lblYearValue.Text = ConvertToJapaneseYear(HEISEI, q14.Year).ToString();

            // xXV
            this.lblSeason.Text = q14.Season;

            // ԋ敪xXV
            this.lblTimeDiv.Text = q14.TimeDiv;

            // IDxXV
            this.lblQuestionIdValue.Text = q14.QuestionNo.ToString();

            // 蕶xXV
            this.lblSentence.Text = q14.Sentence;

            // Iݒ肷
            foreach (Choice choSet in this.lstChoice)
            {
                choSet.Checked = false;
                choSet.Sentence = q14.Choices[this.lstChoice.IndexOf(choSet)];
                choSet.RightAnswer = this.lstChoice.IndexOf(choSet) == q14.Answer;
            }

            // ŏ̑Î݃`FbNԂ
            this.lstChoice[0].Checked = true;

            // ^C}[Jn
            this.tmr.Start();
        }

        /// <summary>
        /// I܂B
        /// </summary>
        private void EndQuestion()
        {
            // 錾
            DialogResult dlr;   // _CAO

            // bZ[W{bNX\
            dlr = MessageBox.Show(Gui.Properties.Message2.C_005, Gui.Properties.MessageTitle2.T_003, MessageBoxButtons.YesNo, MessageBoxIcon.Question);

            if (dlr == DialogResult.Yes)
            {
                // 𓚕\tOɑ
                this.ShowedAnswer = false;

                // Jn
                this.StartQuestion();
            }
            else if (dlr == DialogResult.No)
            {
                // ̉ʂ
                this.Close();
            }
        }
        #endregion
    }
}