//-----------------------------------------------------------------------
// <copyright file="FigureOnlyComboBox.cs">
// </copyright>
//-----------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;

namespace UserControlLibrary
{
    /// <summary>
    /// ̂ݓ͉\ȃR{{bNX
    /// </summary>
    public class FigureOnlyComboBox : ComboBox
    {
        #region private field
        /// <summary>
        /// ͔͈͂i[܂B
        /// </summary>
        private InputScope ips;

        /// <summary>
        /// ȕi[܂B
        /// </summary>
        private List<int> lstDisabledKeys;
        #endregion

        #region public constructor
        /// <summary>
        /// RXgN^
        /// </summary>
        public FigureOnlyComboBox()
        {
            // IME[hɑ
            this.ImeMode = ImeMode.Disable;

            // ͔͈͂
            this.ips = new InputScope(0, 0);

            // Xg
            this.lstDisabledKeys = new List<int>();

            // L[_ECxgnhǉ
            this.KeyDown += new KeyEventHandler(this.FigureOnlyComboBox_KeyDown);

            // L[vXCxgnhǉ
            this.KeyPress += new KeyPressEventHandler(this.FigureOnlyComboBox_KeyPress);
        }
        #endregion

        #region public property
        /// <summary>
        /// ͔͈͂擾yѐݒ肵܂B
        /// </summary>
        public InputScope InputScope
        {
            get
            {
                // ͔͈͂Ԃ
                return this.ips;
            }

            set
            {
                // ͔͈͂ɑ
                this.ips = value;

                // ő啶ݒ
                this.MaxLength = this.ips.End.ToString().Length;

                // ACeSč폜
                this.Items.Clear();

                // ACeǉ
                this.Items.AddRange(CreateItems(this.ips.Start, this.ips.End));
            }
        }
        
        /// <summary>
        /// ȕ擾܂B
        /// </summary>
        public List<int> DisabledKeys
        {
            get { return this.lstDisabledKeys; }
        }
        #endregion

        #region private static method
        /// <summary>
        /// ͔͈͂̃ACe𐶐܂B
        /// </summary>
        /// <returns>͔͈͂̃ACeԂ܂B</returns>
        /// <param name="start">͔͈͂̊Jnn_i[܂B</param>
        /// <param name="end">͔͈͂̏In_i[܂B</param>
        private static object[] CreateItems(int start, int end)
        {
            // 錾
            int i;              // [vϐi
            int intElementSum;  // vvf
            object[] objItems;  // ACez

            // vvfvf
            intElementSum = end - start + 1;

            // ACez̏
            objItems = new object[intElementSum];

            // ACe
            for (i = 0; i < intElementSum; i++)
            {
                // ACez̗vfɑ
                objItems[i] = start + i;
            }

            // ACezԂ
            return objItems;
        }

        /// <summary>
        /// [pfBOĂ邩mF܂B
        /// </summary>
        /// <param name="value">mF镶i[܂B</param>
        /// <returns>݂ȂtrueAłȂȂfalseԂ܂B</returns>
        private static bool CheckZeroPadding(string value)
        {
            if (value != value.TrimStart(new char[] { '0' }))
            {
                return true;
            }

            return false;
        }

        /// <summary>
        /// l͈͊OmF܂B
        /// </summary>
        /// <param name="start">Jnn_i[܂B</param>
        /// <param name="end">In_i[܂B</param>
        /// <param name="value">mFli[܂B</param>
        /// <returns>͈͊OȂtrueAłȂȂfalseԂ܂B</returns>
        private static bool CheckScopeOut(int start, int end, int value)
        {
            if (value < start || value > end)
            {
                return true;
            }

            return false;
        }
        #endregion

        #region private method
        /// <summary>
        /// L[ŏɉꂽ܂B
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void FigureOnlyComboBox_KeyDown(object sender, KeyEventArgs e)
        {
            foreach (int intKeyValue in this.lstDisabledKeys)
            {
                if (intKeyValue == e.KeyValue)
                {
                    e.Handled = true;
                    return;
                }
            }
        }

        /// <summary>
        /// R{{bNXɃtH[JXĂăL[ėꂽ
        /// </summary>
        /// <param name="sender">Cxg̑MłB</param>
        /// <param name="e">MꂽCxgłB</param>
        private void FigureOnlyComboBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            // 錾
            string strTextNew;  // VKeLXg
            int intParsed;      // p[X̒l

            // VKeLXgɑ
            strTextNew = this.Text.Insert(this.SelectionStart, e.KeyChar.ToString());

            if (CheckZeroPadding(strTextNew))
            { // [pfBOĂȂ
                e.Handled = true;
            }
            else if (int.TryParse(strTextNew, out intParsed))
            { // VKeLXgint^ɒȂ
                e.Handled = CheckScopeOut(this.ips.Start, this.ips.End, intParsed);
            }
            else if (e.KeyChar == '\b' && this.SelectionStart != 0)
            { // obNXy[X͂ꂽȂ
                strTextNew = this.Text.Remove(this.SelectionStart - 1, 1);
                if (int.TryParse(strTextNew, out intParsed))
                {
                    e.Handled = CheckScopeOut(this.ips.Start, this.ips.End, intParsed);
                }
            }
            else
            {
                e.Handled = true;
            }
        }
        #endregion
    }
}
