#地雷ゲーム
'''========================================================'''
'''┌更新履歴――――――――――――――――――――――┐'''
'''｜13/08/07  PHPコマンドライン用作成                   ｜'''
'''｜          全ての変数に付加                          ｜'''
'''｜          全入力をfgetsに変更、rewindは削除         ｜'''
'''｜          %cを%sに変更、一部のcontinueに2追加       ｜'''
'''｜          define設定方法変更、各変数にglobal宣言追加｜'''
'''｜          初回の無駄なコメント削除、関数宣言削除    ｜'''
'''｜          関数と引数の型を失くし、宣言に変更        ｜'''
'''｜22/05/11  pythonへ移植                              ｜'''
'''└――――――――――――――――――――――――――┘'''
'''========================================================'''

import os
import random
import sys

''' 定数 ---------------------------------------------------------'''
ON               =  True ;  ''' ON  '''
OFF              =  False ;  ''' OFF '''
OK               =   1 ;  ''' ゲームメインリターン値(クリア) '''
NG               =  -1 ;  ''' ゲームメインリターン値(ゲームオーバー) '''
MEMORY           = 256 ;  ''' 入力用容量 '''
PRINT_CENTER_COL =  12 ;  ''' ウィンドウを広げない場合の表示位置中心(縦) '''
PRINT_CENTER_ROW =  30 ;  ''' ウィンドウを広げない場合の表示位置中心(横) '''
WAIT_TIME        =   99999999 ;  ''' 信頼できない待ち時間(CPU2GHzで約５秒) '''

''' 設定 ---------------------------------------------------------'''
global_col  =   15;  ''' int  行 '''
global_row  =   30;  ''' int  列 '''
debug       =  OFF;  ''' int  爆弾表示 '''
key_up      =  '8';  ''' char ステージ移動上ボタン '''
key_down    =  'k';  ''' char ステージ移動下ボタン '''
key_left    =  'u';  ''' char ステージ移動左ボタン '''
key_right   =  'o';  ''' char ステージ移動右ボタン '''
omake       =    0;  ''' int  １回クリアするとミニゲーム？が・・・ '''
''' --------------------------------------------------------------'''


''' タイトル画面 ==============================================================='''

def main():
    
    #グローバル宣言
    global omake;

    '''  初期化 '''
    select = 0;    ''' 選択 '''
    ret    = 0;    ''' 戻り値を受ける値 '''

    ''' メニュー選択 '''
    while(1):

        title();        ''' タイトル表示 '''

        ''' 選択 '''
        select = 0;
        print("input 1 ～",3+omake,"->",end="");
        select = input();
        if(select.isdecimal()): select=int(select)
        print("");
        ''' ゲーム開始 '''
        if(select == 1):
            ret = game_main();
            if(ret == OK):
                print("clear!!");
                omake = ON;
                delay_wait(WAIT_TIME);
            
            elif(ret == NG):
                print("gameover!!");
                delay_wait(WAIT_TIME);
            
            else:
                '''途中放棄された'''
            
        
        #''' オプション '''
        elif(select == 2):

            option();
        
        elif(select == 3):
            break;
        
        elif( (omake == ON ) & (select == 4 ) ):
            mini_omake();
        
        #''' 終わり '''
        else:
            continue;
        
    
    exit(0);


'''------------------
タイトル表示 
引数　　なし
戻り値　なし
------------------'''
def title():

    #グローバル宣言
    global omake;

    os.system("cls");
    locate( PRINT_CENTER_COL-5 , PRINT_CENTER_ROW-5 );
    print("★☆★　地雷ゲーム　mine game★☆★");
    locate( 0 , PRINT_CENTER_ROW-5 );
    print("～画面端まで辿りつけ！ go to the out!～");
    locate( 1 , PRINT_CENTER_ROW-5 );
    print("(クリアするとおまけが出るよ・・・！)");
    locate( 2 , PRINT_CENTER_ROW+2 );
    print("1.ゲーム開始(start)");
    locate( 2 , PRINT_CENTER_ROW+2 );
    print("2.オプション(option)");
    locate( 2 , PRINT_CENTER_ROW+2 );
    print("3.終わる(end)");
    if(omake == ON):
        locate( 2 , PRINT_CENTER_ROW+2 );
        print("4.おまけ(omake)");
    
    locate( 2 , 0 );

'''=========================================================================='''
'''
関数名  game_main
引数    なし
戻り値  OK,NG
概要    地雷ゲーム本編
'''
def game_main():
    #グローバル宣言
    global global_col;
    global global_row;
    global key_up;
    global key_down;
    global key_left;
    global key_right;

    ''' 初期化 '''
    stage_table = ['-']*global_col*global_row;     ''' ステージ '''
    init_loopcnt = 0;          ''' 初期化用カウンタ '''
    move_select= [] *MEMORY;       ''' 移動の選択 '''
    self_col = (int)(global_col / 2); ''' 自分の位置(縦) '''
    self_row = (int)(global_row / 2); ''' 自分の位置(横) '''
    ret = 0;                   ''' リターン値 '''
    random.seed()

    ''' 爆弾設定 '''
    for init_loopcnt in range(global_col*global_row):
        ''' 10%の確率で爆弾を設置、だけど中心位置には爆弾を置かない '''
        if( (random.randint(1,10)%10 == 1) & (init_loopcnt != (global_col*global_row) / 2) ):
            stage_table[init_loopcnt] = "*";
        
        else:
            stage_table[init_loopcnt] = '-';
        
    

    ''' ゲーム開始 '''
    while(1):
        
        os.system("cls");
        print("");
        map_print(stage_table , self_col , self_row , ret);   ''' マップ表示 '''

        if(ret != 0):
            break;
        
        print("up ->",key_up ,"down ->",key_down ,"left ->",key_left ,"right ->",key_right)
        print("->",end="");
        move_select = input();

        ''' 上↑へ '''
        if( move_select == key_up ):
            self_col-=1;
        
        #''' 下↓へ '''
        elif( move_select == key_down  ):
            self_col+=1;
        
        #''' 左←へ '''
        elif( move_select == key_left ):
            self_row-=1;
        
        #''' 右→へ '''
        elif( move_select == key_right  ):
            self_row+=1;
        
        #''' 途中放棄 '''
        elif( move_select == "exit" ):
            ret = -9;
            break;
        
        else:
            continue;   ''' continueとか、ホントは要らないけど体裁的に何となく '''
        

        ret = clear_judge( stage_table , self_col , self_row );    ''' クリア判定 '''

    ''' while '''

    return ret;


'''-----------------------------------------------------
マップ表示
引数　　char* マップ , 自キャラ縦位置、自キャラ横位置、クリア判定
戻り値　なし
-----------------------------------------------------'''
def map_print(stage_table , self_col , self_row , ret):

    #グローバル宣言
    global global_col;
    global global_row;
    global debug;

    '''宣言'''
    print_col = 0;  ''' 縦の位置 '''
    print_row = 0;  ''' 縦の位置 '''

    ''' ステージ表示 '''
    for print_col in range(global_col) :
        for print_row in range(global_row):
            ''' 自分のいるところ '''
            if( (print_col == self_col) & (print_row == self_row ) ):
                ''' 爆弾じゃなかった場合 '''
                if( stage_table[global_row * self_col + self_row] != "*" ):
                    stage_table[global_row * self_col + self_row] =  "o" ;  ''' 足跡 '''
                    print("#",end="");
                
                else:
                    print("X",end="");
                
            
            else:
                ''' 爆弾部分をどう表示するか '''
                if(stage_table[global_row*print_col + print_row] == "*" ):
                    ''' デバッグモードのとき、もしくは死んだ時、クリアした時、爆弾設置位置表示 '''
                    if( (debug == ON) | (ret != 0)):
                        print("*",end="");
                    
                    #''' 通常モードのとき、爆弾非表示(隠す) '''
                    else:
                        print("-",end="");
                    
                
                #''' その他(足跡や何もないところ) '''
                else:
                    print(stage_table[global_row*print_col + print_row],end="");   ''' -や、oを表示 '''
                
            
        
        print("");
    

'''-----------------------------------------------------
クリア判定
引数　　自キャラ縦位置、自キャラ横位置
戻り値　クリア１、死んだ場合－１、そうでなければ０
-----------------------------------------------------'''

def clear_judge(stage_table , self_col , self_row):

    #グローバル宣言
    global global_col;
    global global_row;

    ''' 初期化 '''
    ret = 0;    ''' 戻り値 '''

    ''' 画面外到達時 '''
    if( ( self_col >= global_col ) | ( self_row >= global_row )
    |  ( self_col <   0          ) | ( self_row <   0          ) ):
        ret = OK;
    
    else:
        ''' 地雷踏んだ時 '''
        if(stage_table[global_row*self_col + self_row] == "*" ):
            ret = NG;
        
    
    return ret;


''' マップ、デバッグ、キーコンフィグ設定 ---------------------------------'''
def option():

    #グローバル宣言
    global global_col;
    global global_row;
    global debug;

    ''' 初期化 '''
    select = 0;
    while(1):
        os.system("cls");

        print("システム設定(os.system set)…");
        locate( 2 , 0 );

        print("  1.マップの『縦』の長さ設定(map col) ->",global_col);
        locate( 2 , 0 );

        print("  2.マップの『横』の長さ設定(map row) ->",global_row);
        locate( 2 , 0 );

        print("  3.デバッグモードの設定(debug) -> ",end="");
        if(debug == ON):print("ON");
        if(debug == OFF):print("OFF");
        locate( 2 , 0 );

        print("  4.キーコンフィグ");
        locate( 2 , 0 );

        print("  5.戻る(return)");
        locate( 2 , 0 );

        select = 0;
        print("input 1 ～ 5 ->",end="");
        select = input();
        if(select.isdecimal()): select=int(select)

        ''' 縦設定 '''
        if(select == 1):
            col_set();
        
        #''' 横設定 '''
        elif(select == 2):
            row_set();
        
        #''' デバッグ設定 '''
        elif(select == 3):
            debug_set();
        
        #''' キーコンフィグ '''
        elif(select == 4):
            key_config();
        
        #''' 戻る '''
        elif(select == 5):
            break;
        
        else:
            continue;
        

    
    return 0;


''' 縦設定------------------------------------- '''
def col_set():

    #グローバル宣言
    global global_col;

    ''' 初期化 '''
    select = 0;

    while(1):
        os.system("cls");
        print("マップの縦の長さ設定(map col) -> ",global_col);
        print("(10～",PRINT_CENTER_COL*2,")");
        locate( 2 , 0 );

        select = 0;
        print("->",end="");
        select = input();
        if(select.isdecimal()): select=int(select)

        ''' 縦設定 '''
        if(10 <= select & select <= PRINT_CENTER_COL*2):
            global_col = select;
            break;
        
    
    return 0;

''' 横設定------------------------------------- '''
def row_set():

    #グローバル宣言
    global global_row;

    ''' 初期化 '''
    select = 0;

    while(1):
        os.system("cls");

        print("マップの横の長さ設定(map row) ->",global_row);
        print("(10～",PRINT_CENTER_ROW*2,")");
        locate( 2 , 0 );

        select = 0;
        print("->",end="");
        select = input();
        if(select.isdecimal()): select=int(select)

        ''' 縦設定 '''
        if(10 <= select & select <= PRINT_CENTER_ROW*2):
            global_row = select;
            break;
        
    
    return 0;

''' デバッグ設定 ---------------------------------------------------'''
def debug_set():

    #グローバル宣言
    global debug;

    ''' 初期化 '''
    select = 9;

    while(1):
        os.system("cls");
        print("デバッグ設定(debug) -> ");
        if(debug == ON):
            print("ON");
        
        else:
            print("OFF");
        
        locate( 1 , 0 );
        print("(ON -> 1 / OFF -> 0)");
        locate( 2 , 0 );

        select = 9;
        print("->",end="");
        select = input();
        if(select.isdecimal()): select=int(select)

        if(select == ON):
            debug = ON;
            break;
        
        elif(select == OFF):
            debug = OFF;
            break;
        
        else:
            continue;
        
    
    return 0;

''' キー設定 -------------------------------------'''
def key_config():

    #グローバル宣言
    global key_up;
    global key_down;
    global key_left;
    global key_right;

    ''' 初期化 '''
    select = 0;

    while(1):
        os.system("cls");
        print("キーコンフィグ(key config)");
        locate( 2 , 0 );

        print("上設定 ->",key_up);
        locate( 1 , 0 );
        print("下設定 ->",key_down);
        locate( 1 , 0 );
        print("左設定 ->",key_left);
        locate( 1 , 0 );
        print("右設定 ->",key_right);
        locate( 1 , 0 );

        print("  1.設定する");
        locate( 2 , 0 );

        print("  他.戻る");
        locate( 2 , 0 );

        select = 0;
        print("->",end="");
        select = input();
        if(select.isdecimal()): select=int(select)

        ''' キー設定 '''
        if(select == 1):
            key_set();
        
        else:
            break;
        
    
    return 0;

''' キー設定 -------------------------------------------------- '''
def key_set():

    #グローバル宣言
    global key_up;
    global key_down;
    global key_left;
    global key_right;

    ''' 初期化 '''
    szbuf = ['']*MEMORY;    ''' どの文字にするか入力用 '''
    charlen = 0;        ''' 入力された文字が1文字であったかを確かめる '''
    set = 1;            ''' 正しく設定された場合、次の設定へ '''

    for i in range(MEMORY):
        szbuf[i]=0;
    

    ''' 上設定 '''
    if set ==  1 :
            while(1):
                os.system("cls");
                print("上 ->" , key_up);
                locate( 2 , 0 );
                print("下 ->" , key_down);
                locate( 2 , 0 );
                print("左 ->" , key_left);
                locate( 2 , 0 );
                print("右 ->" , key_right);
                locate( 2 , 0 );

                print("up ->",end="");
                szbuf = input();

                charlen = len(szbuf);
                if charlen == 1 :
                    key_up = szbuf;
                    set+=1;
                else :
                    continue;
                break;
    ''' 下設定 '''
    if set ==  2 :
            os.system("cls");
            while(1):
                print("上 ->" , key_up);
                locate( 2 , 0 );
                print("下 ->" , key_down);
                locate( 2 , 0 );
                print("左 ->" , key_left);
                locate( 2 , 0 );
                print("右 ->" , key_right);
                locate( 2 , 0 );

                print("down ->",end="");
                szbuf = input();
                charlen = len(szbuf);
                if charlen == 1 :
                    key_down = szbuf;
                    set+=1;
                else:
                    continue ;
                break;
            '''while(正しい入力待ち)'''
            ''' case-breakせずに次の設定へ '''
    ''' 左設定 '''
    if set ==  3 :
            while(1):
                os.system("cls");
                print("上 ->" , key_up);
                locate( 2 , 0 );
                print("下 ->" , key_down);
                locate( 2 , 0 );
                print("左 ->" , key_left);
                locate( 2 , 0 );
                print("右 ->" , key_right);
                locate( 2 , 0 );

                print("left ->",end="");
                szbuf = input();
                charlen = len(szbuf);
                
                if charlen == 1 :
                    key_left = szbuf;
                    set+=1;
                else :
                    continue;
                break;
            '''while(正しい入力待ち)'''
            ''' case-breakせずに次の設定へ '''
    ''' 右設定 '''
    if set ==  4 :
            while(1):
                os.system("cls");
                print("上 ->" , key_up);
                locate( 2 , 0 );
                print("下 ->" , key_down);
                locate( 2 , 0 );
                print("左 ->" , key_left);
                locate( 2 , 0 );
                print("右 ->" , key_right);
                locate( 2 , 0 );

                print("right ->",end="");
                szbuf = input();
                charlen = len(szbuf);
                if charlen == 1 :
                    key_right = szbuf;
                    set+=1;
                else :
                    continue;
                
                break;
            '''while(正しい入力待ち)'''
    #'''case end'''
    else :  
        a=0
    #'''大switch終了'''
    return 0;


'''--------------行------列---'''
def locate(row,col):
    i=0;
    for i in range(row):
        print("");
    
    if(col>0):
        print(" "*col,end='')
    
    return 0;


''' 信頼できない時間の待ち ----------------'''
def delay_wait(wait_time):
    for  i in range(wait_time):
        a=0








''' seacret(色んな意味で全く関係ないです) '''

def mini_omake():
    szbuf=[]*16;

    os.system("cls");
    print("分岐練習");
    print("0.学校への行き方");
    print("他.電話対応");
    szbuf = input();
    if(szbuf.isdecimal()): szbuf=int(szbuf)
    if(szbuf==0):
        os.system("cls");
        goway();
    
    else:
        os.system("cls");
        tel_res();
    
    return 0;



''' 学校へ行く方法(分岐練習) '''
def goway():

    '''初期化'''
    weather = 0;    '''天気'''
    pc = 0;         '''PC'''
    i_loop_cnt = 0; '''ループカウント'''
    n_flg = True;   '''無限ループ抜け用'''

    print("朝起きた。さて、どうやって学校へ行こう。");
    print("雨降ってる？");

    for i in range(9999):
        print("晴れ=1、雨=2　＞",end="");
        weather = input();
        if(weather.isdecimal()): weather=int(weather)
        if(weather == 1):
            break;
        
        elif(weather == 2):
            break;
        
        else:
            continue;
        
    

    print("今日はパソコンの必要な授業はある？");
    
    while(n_flg):
        print("PC必要=1、PC無し=2　＞",end="");
        pc = input();
        if(pc.isdecimal()): pc=int(pc)
        
        if ( (weather == 1) & (pc == 1) ):
            print("――――――――――――――――――――――――――――― ");
            print("車で行こう！(⊂^∀^)⊃ブーン");
            print("鞄はリュックと肩掛けだぜ！");
            n_flg = False;
        
        elif ( (weather == 1) & (pc == 2) ):
            print("――――――――――――――――――――――――――――― ");
            print("車で行こう！(⊂^∀^)⊃ブーン");
            print("鞄は肩掛けのみだぜ！");
            n_flg = False;
        
        elif ( ( weather == 2 ) & ( pc == 2 ) ):
            print("――――――――――――――――――――――――――――― ");
            print("歩いて行こう！ε≡「(*^ー^)」^^^");
            print("鞄はリュックだぜ！");
            n_flg = False;
        
        elif ( ( weather == 2 ) & ( pc == 1 ) ):
            print("――――――――――――――――――――――――――――― ");
            print("電車で行こう(´・ω・｀)電車代がショボーン(お金ないのに)");
            print("鞄はリュックと肩掛け。");
            print("帰りは徒歩だよ。");
            n_flg = False;
        
        else:
            n_flg = True;
            continue;
        
    
    print("――――――――――――――――――――――――――――― ");
    delay_wait(WAIT_TIME);
    return 0;







''' 電話対応 -----------------------------'''
def tel_res():
    tel=None;
    when=None;
    who=None;
    be=None;
    who2=None;
    where1=None;
    ans=None;
    number=None;

    '''============================'''
    '''    電話キター！(;ﾟДﾟ)     '''
    '''============================'''
    print("電話取る？→1 or 他　",end="");
    tel = input();
    if(tel.isdecimal()): tel=int(tel)
    if(tel == 1):
        a=0
    else:
        print("誰かに先に取られた");
        return 0;
    
    '''================'''
    '''    何時？      '''
    '''================'''
    print("何時？→午前＝0、午後＝他　",end="");
    when = input();
    if(when.isdecimal()): when=int(when)

    if(when == 0 ):
        print("「おはようございます。株式会社です。」");
    
    else:
        print("「ありがとうございます。株式会社です。」");
    
    '''=========='''
    '''    誰？  '''
    '''=========='''
    print("誰？→客＝他、社員＝9　",end="");
    who = input();
    if(who.isdecimal()): who=int(who)

    if(who != 9):
        print("「お世話になっております。」");
    
    if(who == 9):
        print("「お疲れ様です。」");
    
    
    print("誰々居ませんか");
    print("「少々お待ち下さい。」");
    '''================'''
    '''    居る？      '''
    '''================'''
    print("居る？→居る＝1、居ない＝他　",end="");
    be = input();
    if(be.isdecimal()): be=int(be)

    '''================'''
    '''    居る場合    '''
    '''================'''
    if(be == 1 ):
        while(1):
            '''=========='''
            '''    誰？  '''
            '''=========='''
            print("誰？→社長＝1、部長＝2、課長＝3　",end="");
            who2 = input();
            if(who2.isdecimal()): who2=int(who2)

            if(who2 == 1):
                print("「社長、何処々の誰々様からお電話です。」");
                return 0;
            
            if(who2 == 2 ):
                print("「部長、何処々の誰々様からお電話です。」");
                return 0;
            
            if(who2 == 3 ):
                print("「課長、何処々の誰々様からお電話です。」");
                return 0;
            
            else:
                a=0
        
    
    #'''======================'''
    #'''    居なかった場合    '''
    #'''======================'''
    else:
        '''======================'''
        '''    何してんの？      '''
        '''======================'''
        print("どこ？→外出＝1、会議＝2、来客接待＝3、別の電話対応＝4、席を外している＝他",end="");
        where1= input();
        if(where1.isdecimal()): where1=int(where1)

        print("「お待たせしました。申し訳御座いません。");
        print("　誰々は只今");
        if(where1 == 1 ):
            print("外出しておりまして、何時に戻る予定となっております。");
        
        elif(where1 == 2 ):
            print("会議中でして、終わり次第、");
        
        
        elif(where1 == 3 ):
            print("来客接待中でして、終わり次第、");
        
        
        elif(where1 == 4 ):
            print("別の電話対応中でして、終わり次第、");
        
        else:
            print("席を外しております。戻り次第、");
        
        print("　こちらから折り返しお電話させましょうか？」");
    
    '''================'''
    '''    ＯＫ？      '''
    '''================'''
    print("ＯＫ？→OK＝1、NO＝他　",end="");
    ans= input();
    if(ans.isdecimal()): ans=int(ans)

    '''================'''
    '''    社員の場合  '''
    '''================'''
    if(who == 9 ):
        
        '''=========='''
        '''    ＯＫ  '''
        '''=========='''
        if(ans == 1 ):
            print("「了解しました。伝えておきます。");
            print("　お疲れ様でした。」");
            return 0;
        
        #'''=========='''
        #'''    ＮＯ  '''
        #'''=========='''
        else:
            print("「はい、了解しました。申し訳ございません。");
            print("　ありがとうございました。失礼致します。」");
        
    
    '''======================'''
    '''    お客様の場合      '''
    '''======================'''
    if(who != 9 ):
        '''=========='''
        '''    ＯＫ  '''
        '''=========='''
        if(ans == 1 ):
            print("「ご連絡先をお伺いしてもよろしいでしょうか？番号→",end="");
            number= input();
            if(number.isdecimal()): number=int(number)

            print("「",number,"、何処々の何々様ですね。了解しました。伝えておきます。");
            print("　ありがとうございました。失礼致します。」");
        
        #'''=========='''
        #'''    ＮＯ  '''
        #'''=========='''
        else:
            print("「はい、了解しました。申し訳ございません。");
            print("　ありがとうございました。失礼致します。」");
        
    
    delay_wait(WAIT_TIME);
    return 0;

main();
